﻿;==============================================================================================================================================================================
; Copyright:    MGB Technical Services, 2018.
; 
; License:      Freeware. Do what you want with it EXCEPT SELL IT which is expressly forbidden, acknowledge the source 
;               please. License for the expat XML parser is in the distribution directory. 'Expat XML parser license.txt'
; 
; Code format:  Purebasic, v5.63x X86 source code project.
; 
; Dependancies: None.
; 
; Graphics:     Most graphics came from the Mattahan's BUUF sets
; 
; Thanks:       My wife Susan!!! InfraTec, ElectroChrisso, Rashad, NetMaestro and a cast of thousands
;
; Notes:        I've tried to comment wherever I could but there are just so many hours in the day. The code is 100% finished
;               as far as I am concerned. I you want more, ask me or code it in yourself, you have the source code.
; 
;               I've tried to overload the options available to users. Menu options are duplicated by keyboard shortcuts.
;
; Addendum:     Before you complain that this program has destroyed something or did something you didn't like, have the 
;               decency and intelligence to actually read through the code and NOT TEST IT on LIVE DATA but copies. It is
;               NOT MY JOB to rescue you from your own laziness or obdurate stupidity. I have slaved my hairy ass off for
;               for this program. You are a coder and presumably know what you are doing.
; 
; Changes:      Error log module and assembly error catcher in case debug doesn't always work properly. It doesn't here.
; 
; Notes:        The error log is rewritten every time you start the program, to the same name as the program name and version.
;               No dated logs as I didn't want tons of temp log files to follow. And it is also flushed to disk every 50
;               entries or at program end to minimise disk writes in case you are running on a USB key.
; 
;               I've tried to minimise database queries for the same reason as well.
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;/ Created with PureVision v5.63
;/ Wed, 31 Oct 2018 12:39:54
;/ by Miklos Bolvary
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Load a registered user's name above the search bar. For the heck of it.
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

ParameterCount.i = CountProgramParameters()                                                               ; 

If ParameterCount.i <>  0                                                                                 ; 
  If ProgramParameter(0) = "/Register"                                                                    ; 
    FirstName.s = ProgramParameter(1)                                                                     ; 
    LastName.s  = ProgramParameter(2)                                                                     ; 
  EndIf                                                                                                   ; 
EndIf                                                                                                     ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Prevent multiple instances of Keeper from starting
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Keeper_Startup.pbi"                                                                         ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Don't use this while in the IDE as internal debugger may not work right
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Generic\_ErrorHandler.pbi"                                                          ; A generic error handler for reporting crashes.

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Add the external error handler if needed
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

OnErrorCall(@ErrorHandler())                                                                              ; Handle errors properly

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Keeper_Constants.pb"                                                                        ; Visual designer created constants
XIncludeFile "Keeper_Windows.pb"                                                                          ; Visual designer created window code
XIncludeFile "Keeper_MyDeclarations.pb"                                                                   ; My procedural declarations
XIncludeFile "Keeper_MyConstants.pb"                                                                      ; My personal constants

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Third party routines
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\ThirdParty\_NM_MouseHover.pbi"                                                     ; Mouse Hover library  (NetMaestro)
XIncludeFile "Modules\ThirdParty\_RS_PrintRtfGadget.pbi"                                                 ; Print from the RTF gadget. Also other routines, Load, save etc (RASHAD)
XIncludeFile "Modules\ThirdParty\_TH_RtfTools.pbi"                                                       ; Richedit handling (Freak (Timo Harter), Srod (Stephen Rodriguez), Sparkie (Mark Budny), others)
XIncludeFile "Modules\ThirdParty\_SG_WebgadgetPrint.pbi"                                                 ; Print without prompts from the web gadget (Siggi (Sigfried Rings))

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Generic routines
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Generic\_FormatField.pbi"                                                           ; Format the passed string to the correct field length for printing/copying to clipboard etc
XIncludeFile "Modules\Generic\_FormatMenu.pbi"                                                            ; Format menu text and shortcut strings to a predefined length
XIncludeFile "Modules\Generic\_GetShortcutText.pbi"                                                       ; Get the text of the associated shortcut constant
XIncludeFile "Modules\Generic\_KillQuote.pbi"                                                             ; Kill double quotes in strings for display purposes
XIncludeFile "Modules\Generic\_LastLine.pbi"                                                              ; Go to the last line of a ListIconGadget
XIncludeFile "Modules\Generic\_MakeString.pbi"                                                            ; Create a string of spaces or other characters. Pass it any number of characters and watch it grow!
XIncludeFile "Modules\Generic\_MakeSureDirectoryPathExists.pbi"                                           ; Need a unicode aware version of the API directory creator
XIncludeFile "Modules\Generic\_MixedComboCaseEx.pbi"                                                      ; First letter uppercase in a combo box. srod!.
XIncludeFile "Modules\Generic\_MixedStringCase.pbi"                                                       ; Uppercase the first letter of each word
XIncludeFile "Modules\Generic\_ProperCaseString.pbi"                                                      ; Flip a mixed string into all proper case
XIncludeFile "Modules\Generic\_RepQuote.pbi"                                                              ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
XIncludeFile "Modules\Generic\_RemoveBorders.pbi"                                                         ; Remove borders from various gadgets
XIncludeFile "Modules\Generic\_SetSearchQuery.pbi"                                                        ; Alias the Search type text to SQLite operators
XIncludeFile "Modules\Generic\_StringFirstUpper.pbi"                                                      ; Convert the first character of a string to uppercase
XIncludeFile "Modules\Generic\_TextToXML.pbi"                                                             ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
XIncludeFile "Modules\Generic\_xcm.pbi"                                                                   ; Calculate x axis movement for printer dimensions
XIncludeFile "Modules\Generic\_XMLToText.pbi"                                                             ; Strip illegal characters from text strings
XIncludeFile "Modules\Generic\_ycm.pbi"                                                                   ; Calculate y axis movement for printer dimensions

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Custom form and information handling
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Custom\_BalloonToolTip.pbi"                                                         ; Add balloon tooltips with individual fonts and icons
XIncludeFile "Modules\Custom\_CheckEnterGadget.pbi"                                                       ; Check which gadget had the focus at the time ENTER was pressed
XIncludeFile "Modules\Custom\_CloseMyWindow.pbi"                                                          ; Fade the window out gently, close it and reset the mutex
XIncludeFile "Modules\Custom\_GetIconHandle.pbi"                                                          ; Copy the icon into memory while deleting the original image copied from
XIncludeFile "Modules\Custom\_GetPartBetweenBrackets.pbi"                                                 ; Extract the text between pointy brackets
XIncludeFile "Modules\Custom\_IsoDate.pbi"                                                                ; Convert an ISO format date to Australian and back
XIncludeFile "Modules\Custom\_SetInfoBarArea.pbi"                                                         ; Send messages and error reports to the fake status bar area
XIncludeFile "Modules\Custom\_SetHoverIcons.pbi"                                                          ; Set the correct icons to the selected hoverable gadget
XIncludeFile "Modules\Custom\_SortTitleStrings.pbi"                                                       ; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
XIncludeFile "Modules\Custom\_StatusBarButtonTip.pbi"                                                     ; Custom statusbar tooltip messages
XIncludeFile "Modules\Custom\_TitleBarClock.pbi"                                                          ; Run an asynchronous clock in the window title bar
XIncludeFile "Modules\Custom\_WriteErrorLog.pbi"                                                          ; Write the error log to disk in the temporary directory
XIncludeFile "Modules\Custom\_WordWrapString.pbi"                                                         ; Wrap a string to a specified boundary

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Custom form callbacks
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Callbacks\_MainWindowCallback.pbi"                                                  ; Window snap, strikeoutfont and more

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Database functions
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Database\_CountRecords.pbi"                                                         ; Count the number of records in an SQLite database
XIncludeFile "Modules\Database\_DatabaseLastInsertRowId.pbi"                                              ; Get the ID of the last inserted record
XIncludeFile "Modules\Database\_FillCombo.pbi"                                                            ; Fill a combobox gadget from a linked list, SQLite version
XIncludeFile "Modules\Database\_FillComboBoxImage.pbi"                                                    ; Fill a combobox with items and their stored images
XIncludeFile "Modules\Database\_LastRecord.pbi"                                                           ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
XIncludeFile "Modules\Database\_OpenSystemDatabase.pbi"                                                   ; Try to open the system database and create missing tables

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Export and import routines, File menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Filemenu\_BackupDatabase.pbi"                                                       ; Backup the current database to the named day of the week
XIncludeFile "Modules\Filemenu\_ExportDatabase.pbi"                                                       ; Export data data to a standard XML file
XIncludeFile "Modules\Filemenu\_ImportDatabase.pbi"                                                       ; Import an XML file of keeper entries
XIncludeFile "Modules\Filemenu\_ProcessKeeperNode.pbi"                                                    ; Decode Keeper node data
XIncludeFile "Modules\Filemenu\_VacuumDeletedData.pbi"                                                    ; Clean all deleted items from the database immediately

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Categories management, Category menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Categorymenu\_AddCategory.pbi"                      ; *** Window ***                ; Add a new category to the database
XIncludeFile "Modules\Categorymenu\_ChangeCategory.pbi"                                                   ; Change the category of the title that was dropped to what it was dropped on
XIncludeFile "Modules\Categorymenu\_CopyCategory.pbi"                                                     ; Copy the current category to the clipboard
XIncludeFile "Modules\Categorymenu\_DeleteCategory.pbi"                                                   ; Delete the selected category
XIncludeFile "Modules\Categorymenu\_DragToCategory.pbi"                                                   ; Change the category of a title by dragging and dropping it onto the category bar
XIncludeFile "Modules\Categorymenu\_EditCategory.pbi"                     ; *** Window ***                ; Edit the selected category
XIncludeFile "Modules\Categorymenu\_ExportCategories.pbi"                                                 ; Export the list of categories to disk
XIncludeFile "Modules\Categorymenu\_ImportCategories.pbi"                                                 ; Import a text file list of categories from disk
XIncludeFile "Modules\Categorymenu\_LoadCategories.pbi"                                                   ; Load all the categories into the category bar
XIncludeFile "Modules\Categorymenu\_SaveCategory.pbi"                                                     ; Save the changed category data to the database
XIncludeFile "Modules\Categorymenu\_ShowCategory.pbi"                                                     ; Show the items that belong to a particular category
XIncludeFile "Modules\Categorymenu\_SortCategoryEntries.pbi"                                              ; Sort the category list after an add or edit
XIncludeFile "Modules\Categorymenu\_UpdateCategoryItemCount.pbi"                                          ; Update the category itemcount field each time we add, change or delete addresses or categories

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All data handling, Data menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Datamenu\_AddNewData.pbi"                           ; *** Window ***                ; Add a new Keeper item
XIncludeFile "Modules\Datamenu\_ArchiveThisData.pbi"                                                      ; Archive this stuff to permanent storage
XIncludeFile "Modules\Datamenu\_AttachItemToData.pbi"                                                     ; Attach a document or file to the current record
XIncludeFile "Modules\Datamenu\_CopyDataToClipboard.pbi"                                                  ; Copy highlighted data to the system clipboard
XIncludeFile "Modules\Datamenu\_DataFormTemplate.pbi"                                                     ; Standard data form template for convenience
XIncludeFile "Modules\Datamenu\_DeleteCurrentData.pbi"                                                    ; Mark the selected item as deleted
XIncludeFile "Modules\Datamenu\_DisplayTitleString.pbi"                                                   ; Display Keeper title in the list
XIncludeFile "Modules\Datamenu\_EditOldData.pbi"                          ; *** Window ***                ; Edit the old Keeper data
XIncludeFile "Modules\Datamenu\_ExportItemToDisk.pbi"                                                     ; Export the currently selected item to disk
XIncludeFile "Modules\Datamenu\_ImportItemFromDisk.pbi"                                                   ; Import a preformatted text file from disk
XIncludeFile "Modules\Datamenu\_KillCurrentData.pbi"                                                      ; Lock the current record against deletion and editing
XIncludeFile "Modules\Datamenu\_LockCurrentData.pbi"                                                      ; Lock the current record against deletion and editing
XIncludeFile "Modules\Datamenu\_MarkAsFavourite.pbi"                                                      ; Mark this entry as a favourite item
XIncludeFile "Modules\Datamenu\_PrintThisData.pbi"                                                        ; Print all or selected records    ; 
XIncludeFile "Modules\Datamenu\_SaveThisData.pbi"                                                         ; Save the new or edited Keeper data
XIncludeFile "Modules\Datamenu\_SearchData.pbi"                                                           ; Search within the data form itself
XIncludeFile "Modules\Datamenu\_SearchForData.pbi"                                                        ; Show all the items in the database
XIncludeFile "Modules\Datamenu\_ShowKeeperData.pbi"                                                       ; Show the data string for Keeper on the screen
XIncludeFile "Modules\Datamenu\_UpdateTitleAttachmentCount.pbi"                                           ; Update the attachment counter in the title list

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Utilities menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Utilitymenu\_AdvancedSearch.pbi"                    ; *** Window ***                ; Search Keeper's database with advanced SQL tools and limits
XIncludeFile "Modules\Utilitymenu\_AdvancedSearchNow.pbi"                                                 ; Perform the extended SQL search now
XIncludeFile "Modules\Utilitymenu\_SelectAllItems.pbi"                                                    ; Select all the data in the list for some operations

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Utilities menu, Owner management
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Owners\_ManageOwners.pbi"                           ; *** Window ***                ; Manage the owner list table
XIncludeFile "Modules\Owners\_AddOwner.pbi"                                                               ; Add a new Owner to the Owner bar
XIncludeFile "Modules\Owners\_CopyOwner.pbi"                                                              ; Copy the current owner to the clipboard
XIncludeFile "Modules\Owners\_DeleteOwner.pbi"                                                            ; Delete an existing Owner from the owner bar
XIncludeFile "Modules\Owners\_EditOwner.pbi"                                                              ; Edit the old owner in the database
XIncludeFile "Modules\Owners\_SaveOwner.pbi"                                                              ; Save the new or changed Owner information
XIncludeFile "Modules\Owners\_SortOwners.pbi"                                                             ; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
XIncludeFile "Modules\Owners\_UpdateOwnerItemCount.pbi"                                                   ; Update the Owner itemcount field each time we add, change or delete owners

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Program toggles, Options menu  
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Optionsmenu\_ToggleBalloonToolTips.pbi"                                             ; Turn balloon tooltips on or off
XIncludeFile "Modules\Optionsmenu\_ToggleColourBand.pbi"                                                  ; Turn alternate row colour banding on and off
XIncludeFile "Modules\Optionsmenu\_ToggleHideDetail.pbi"                                                  ; Turn the hiding of the detail pane on or off
XIncludeFile "Modules\Optionsmenu\_ToggleMessageSave.pbi"                                                 ; Turn on or off messages after saving
XIncludeFile "Modules\Optionsmenu\_ToggleWindowToolBars.pbi"                                              ; Turn on or off the showing of the main toolbar
XIncludeFile "Modules\Optionsmenu\_ToggleScreenSnap.pbi"                                                  ; Turn snapping to screen borders on and off
XIncludeFile "Modules\Optionsmenu\_ToggleStickyWindow.pbi"                                                ; Set this window on top of others or alarm window will not show
XIncludeFile "Modules\Optionsmenu\_ToggleTitleBarClock.pbi"                                               ; Turn time updating on in the title bar

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Program help, Help menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Helpmenu\_AboutKeeper.pbi"                          ; *** Window                    ; A quick 'about me' blurb
XIncludeFile "Modules\Helpmenu\_Keyboardshortcuts.pbi"                    ; *** Window                    ; Show a list of all the keyboard shortcuts
XIncludeFile "Modules\Helpmenu\_ViewErrorLog.pbi"                         ; *** Window                    ; View the system error log file

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Help modules
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Helpscreens\_EditHelp.pbi"                                                          ; Change the current read only state of the current help page
XIncludeFile "Modules\Helpscreens\_LoadHelp.pbi"                                                          ; Load an Rtf text file into the help area
XIncludeFile "Modules\Helpscreens\_SaveHelp.pbi"                                                          ; Save the current help contents to an Rtf text file on disk
XIncludeFile "Modules\Helpscreens\_SearchHelp.pbi"                                                        ; Search the Keeper help file and highlight text. RASHAD
XIncludeFile "Modules\Helpscreens\_ShowHelp.pbi"                          ; *** Window                    ; Adaptable help file that loads RTF from datasection
XIncludeFile "Modules\Helpscreens\_PrintHelp.pbi"                                                         ; Print the contents of the current help page

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Create a new password if there wasn't one previously
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Security\_NewPassWordWindow.pbi"                                                    ; Open the new password window
XIncludeFile "Modules\Security\_CheckNewPassWord.pbi"                     ; *** Window ***                ; Check that there is a new password

; Security password check on program startup

XIncludeFile "Modules\Security\_StartPassWordWindow.pbi"                  ; *** Window ***                ; Show a password lock screen at program start
XIncludeFile "Modules\Security\_CheckStartUpPassWord.pbi"                                                 ; Check the startup unlocking password

; Edit an existing password

XIncludeFile "Modules\Security\_EditpassWordWindow.pbi"                   ; *** Window ***                ; Open the edit password window
XIncludeFile "Modules\Security\_CheckpassWords.pbi"                                                       ; Check that the old password and confirmation passwords match

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Lock and unlock the program window
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Security\_LockProgramWindow.pbi"                                                    ; Lock the program window now
XIncludeFile "Modules\Security\_CheckUnlockPassWord.pbi"                                                  ; Check the unlocking password
XIncludeFile "Modules\Security\_UnLockProgramWindow.pbi"                  ; *** Window                    ; UnLock the program window now

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Minimising and maximising the program window
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Security\_HideProgramWindow.pbi"                                                    ; Hide the program window
XIncludeFile "Modules\Security\_ShowProgramWindow.pbi"                                                    ; Show the program window

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Modules required to run only once for various database changes
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;XIncludeFile "Modules\Onetime\_OneTimeCategoryUpdate.pbi"                                                 ; Update category item count in category list
;XIncludeFile "Modules\Onetime\_OneTimeMakeOwners.pbi"                                                     ; Create the new owners table on startup and insert them
;XIncludeFile "Modules\Onetime\_OneTimeOwnerUpdate.pbi"                                                    ; Update category item count in owner list and create the list of owners list
;XIncludeFile "Modules\Onetime\_OneTimeConvertRtfDatabase.pbi"                                             ; Convert the rtf data in the info field to normal text

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Vosual designer bound resizing. 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; Procedure SizeWindowHandler()
;   PVDynamic_Resize(WindowID(EventWindow())) 
; EndProcedure
; 
; BindEvent(#PB_Event_SizeWindow, @SizeWindowHandler())

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Main program event handlers
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

If Window_Keeper()
  
  ;------------------------------------------------------------------------------------------------
  ; Check for executable being run more than once
  ;------------------------------------------------------------------------------------------------
  
  If Instance_Running(VersionFileName.s)
    StickyWindow(#Window_Keeper, #True)
    ErrorMessage.s = VersionFileName.s + " is already running."  + #CRLF$
    ErrorMessage.s + "Cannot start another instance!"
    MessageRequester("Program already running", ErrorMessage.s,  #MB_ICONWARNING)
    End
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Open the master database from which we also pull the setup data.
  ;------------------------------------------------------------------------------------------------

  OpenSystemDatabase()                                                                                       ; Open the system database

  ;------------------------------------------------------------------------------------------------
  ; Read the program startup preferences
  ;------------------------------------------------------------------------------------------------
  
  PreferencesQueryString.s  + 
  "SELECT "                 + 
  "* "                      + 
  "FROM Preferences "       + 
  "WHERE Record = '1'"
  
  If DatabaseQuery(Program\DatabaseHandle, PreferencesQueryString.s) <> #DatabaseQueryFail
    While NextDatabaseRow(Program\DatabaseHandle)
      
      Program\MD5FingerPrint =           GetDatabaseString(Program\DatabaseHandle,  0)
      
      Program\SearchLimit    =           GetDatabaseString(Program\DatabaseHandle,  1)
      Program\LastSearch     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))
      
      Toggle\BalloonTooltips =       Val(GetDatabaseString(Program\DatabaseHandle,  3))
      Toggle\ColourBand      =       Val(GetDatabaseString(Program\DatabaseHandle,  4))
      Toggle\HideDetail      =       Val(GetDatabaseString(Program\DatabaseHandle,  5))
      Toggle\MessageSave     =       Val(GetDatabaseString(Program\DatabaseHandle,  6))
      Toggle\ShowToolbar     =       Val(GetDatabaseString(Program\DatabaseHandle,  7))
      Toggle\ScreenSnap      =       Val(GetDatabaseString(Program\DatabaseHandle,  8))
      Toggle\StickyWindow    =       Val(GetDatabaseString(Program\DatabaseHandle,  9))
      Toggle\TitleClock      =       Val(GetDatabaseString(Program\DatabaseHandle, 10))
    Wend
    FinishDatabaseQuery(Program\DatabaseHandle)
  Else
    MessageRequester("Options Read Error", "Could not read the options from the database. " + DatabaseError(), #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; If no password, get a new one or open the password window if one exists
  ;------------------------------------------------------------------------------------------------
  
  If Program\MD5FingerPrint = #Empty$
    NewPassWordWindow()
  ElseIf  Program\MD5FingerPrint <> #Empty$
    StartPassWordWindow()
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Show the registered user name above the search bars.
  ;------------------------------------------------------------------------------------------------
  
  If FirstName.s <> #Empty$ And LastName.s <> #Empty$
    SetGadgetText(#Gadget_Keeper_lRegistration, #Fish + ", Program: ["  + #Basename + #Version + Program\CompileCounters  + "], Status:  [Freeware], Registered To: " + FirstName.s + " "  + LastName.s)
  Else
    SetGadgetText(#Gadget_Keeper_lRegistration, #Fish + ", Program: ["  + #Basename + #Version + Program\CompileCounters  + "], Status:  [Freeware], Registered to: [No registration name found]")
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Fix the ItemCount field in the category table on database changes
  ;------------------------------------------------------------------------------------------------
  
  ; OneTimeCategoryUpdate()
  
  ;------------------------------------------------------------------------------------------------
  ; Create the owners table because it's not in the old Keeper format
  ;------------------------------------------------------------------------------------------------
  
  ; OneTimeMakeOwners()
  
  ;------------------------------------------------------------------------------------------------
  ; Fix the ItemCount field in the owner table on database changes
  ;------------------------------------------------------------------------------------------------
  
  ; OneTimeOwnerUpdate()
  
  ;------------------------------------------------------------------------------------------------
  ; Convert the rtf data in the info field to normal text as it's looks bad printed
  ;------------------------------------------------------------------------------------------------
  
  ; OneTimeConvertRtfDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; Deleteed font, screen snapping and more
  ;------------------------------------------------------------------------------------------------
  
  SetWindowCallback(@MainWindowCallback())
  
  ;------------------------------------------------------------------------------------------------
  ; Create the main program menu
  ;------------------------------------------------------------------------------------------------
  
  If CreateImageMenu(#MenuBar_Keeper, WindowID(#Window_Keeper))
    MenuTitle("Files")
    MenuItem(#MenuBar_Keeper_BackupDatabase,    ShortTooltip\BackupDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_BackupDatabase),    ImageID(#MenuBarIcon_Keeper_BackupDatabase))
    MenuItem(#MenuBar_Keeper_ExportDatabase,    ShortTooltip\ExportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ExportDatabase),    ImageID(#MenuBarIcon_Keeper_ExportDatabase))
    MenuItem(#MenuBar_Keeper_ImportDatabase,    ShortTooltip\ImportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ImportDatabase),    ImageID(#MenuBarIcon_Keeper_ImportDatabase))
    MenuItem(#MenuBar_Keeper_VacuumDatabase,    ShortTooltip\VacuumDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_VacuumDatabase),    ImageID(#MenuBarIcon_Keeper_VacuumDatabase))
    MenuBar()
    MenuItem(#MenuBar_Keeper_ExitProgram,       ShortTooltip\ExitProgram       + #TAB$ + GetShortcutText(#ShortcutValue_ExitProgram),       ImageID(#MenuBarIcon_Keeper_ExitProgram))
    MenuTitle("Categories")
    MenuItem(#MenuBar_Keeper_AddCategory,       ShortTooltip\AddCategory       + #TAB$ + GetShortcutText(#ShortcutValue_AddCategory),       ImageID(#MenuBarIcon_Keeper_AddCategory))
    MenuItem(#MenuBar_Keeper_CopyCategory,      ShortTooltip\CopyCategory      + #TAB$ + GetShortcutText(#ShortcutValue_CopyCategory),      ImageID(#MenuBarIcon_Keeper_CopyCategory))
    MenuItem(#MenuBar_Keeper_DeleteCategory,    ShortTooltip\DeleteCategory    + #TAB$ + GetShortcutText(#ShortcutValue_DeleteCategory),    ImageID(#MenuBarIcon_Keeper_DeleteCategory))
    MenuItem(#MenuBar_Keeper_EditCategory,      ShortTooltip\EditCategory      + #TAB$ + GetShortcutText(#ShortcutValue_EditCategory),      ImageID(#MenuBarIcon_Keeper_EditCategory))
    MenuBar()
    MenuItem(#MenuBar_Keeper_ExportCategories,  ShortTooltip\ExportCategories  + #TAB$ + GetShortcutText(#ShortcutValue_ExportCategories),  ImageID(#MenuBarIcon_Keeper_ExportCategories))
    MenuItem(#MenuBar_Keeper_ImportCategories,  ShortTooltip\ImportCategories  + #TAB$ + GetShortcutText(#ShortcutValue_ImportCategories),  ImageID(#MenuBarIcon_Keeper_ImportCategories))
    MenuTitle("Data")
    MenuItem(#MenuBar_Keeper_AddItem,           ShortTooltip\AddItem           + #TAB$ + GetShortcutText(#ShortcutValue_AddItem),           ImageID(#MenuBarIcon_Keeper_AddItem))
    MenuItem(#MenuBar_Keeper_ArchiveItem,       ShortTooltip\ArchiveItem       + #TAB$ + GetShortcutText(#ShortcutValue_ArchiveItem),       ImageID(#MenuBarIcon_Keeper_ArchiveItem))
    MenuItem(#MenuBar_Keeper_AttachItem,        ShortTooltip\AttachItem        + #TAB$ + GetShortcutText(#ShortcutValue_AttachItem),        ImageID(#MenuBarIcon_Keeper_AttachItem))
    MenuItem(#MenuBar_Keeper_CopyItem,          ShortTooltip\CopyItem          + #TAB$ + GetShortcutText(#ShortcutValue_CopyItem),          ImageID(#MenuBarIcon_Keeper_CopyItem))
    MenuItem(#MenuBar_Keeper_DeleteItem,        ShortTooltip\DeleteItem        + #TAB$ + GetShortcutText(#ShortcutValue_DeleteItem),        ImageID(#MenuBarIcon_Keeper_DeleteItem))
    MenuItem(#MenuBar_Keeper_EditItem,          ShortTooltip\EditItem          + #TAB$ + GetShortcutText(#ShortcutValue_EditItem),          ImageID(#MenuBarIcon_Keeper_EditItem))
    MenuItem(#MenuBar_Keeper_ExportItem,        ShortTooltip\Exportitem        + #TAB$ + GetShortcutText(#ShortcutValue_ExportItem),        ImageID(#MenuBarIcon_Keeper_ExportItem))
    MenuItem(#MenuBar_Keeper_FavouriteItem,     ShortTooltip\FavouriteItem     + #TAB$ + GetShortcutText(#ShortcutValue_FavouriteItem),     ImageID(#MenuBarIcon_Keeper_FavouriteItem))
    MenuItem(#MenuBar_Keeper_ImportItem,        ShortTooltip\ImportItem        + #TAB$ + GetShortcutText(#ShortcutValue_ImportItem),        ImageID(#MenuBarIcon_Keeper_ImportItem))
    MenuItem(#MenuBar_Keeper_KillItem,          ShortTooltip\KillItem          + #TAB$ + GetShortcutText(#ShortcutValue_KillItem),          ImageID(#MenuBarIcon_Keeper_KillItem))
    MenuItem(#MenuBar_Keeper_LockItem,          ShortTooltip\LockItem          + #TAB$ + GetShortcutText(#ShortcutValue_LockItem),          ImageID(#MenuBarIcon_Keeper_LockItem))
    MenuItem(#MenuBar_Keeper_PrintItem,         ShortTooltip\PrintItem         + #TAB$ + GetShortcutText(#ShortcutValue_PrintItem),         ImageID(#MenuBarIcon_Keeper_PrintItem))
    MenuBar()
    MenuTitle("Utilities")
    MenuItem(#MenuBar_Keeper_AdvancedSearch,    ShortTooltip\AdvancedSearch    + #TAB$ + GetShortcutText(#ShortcutValue_AdvancedSearch),    ImageID(#MenuBarIcon_Keeper_AdvancedSearch))
    MenuItem(#MenuBar_Keeper_SelectAllItems,    ShortTooltip\SelectAllItems    + #TAB$ + GetShortcutText(#ShortcutValue_SelectAllItems),    ImageID(#MenuBarIcon_Keeper_SelectAllItems))
    MenuBar()
    MenuItem(#MenuBar_Keeper_OwnerManagement,   ShortTooltip\OwnerManagement   + #TAB$ + GetShortcutText(#ShortcutValue_OwnerManagement),   ImageID(#MenuBarIcon_Keeper_OwnerManagement))
    MenuBar()
    MenuItem(#MenuBar_Keeper_EditPassword,      ShortTooltip\EditPassword      + #TAB$ + GetShortcutText(#ShortcutValue_EditPassword),      ImageID(#MenuBarIcon_Keeper_EditPassword))
    MenuItem(#MenuBar_Keeper_LockProgram,       ShortTooltip\LockProgram       + #TAB$ + GetShortcutText(#ShortcutValue_LockProgram),       ImageID(#MenuBarIcon_Keeper_LockProgram))
    MenuTitle("Options")
    MenuItem(#MenuBar_Keeper_BalloonTooltips,   ShortTooltip\BalloonTooltips   + #TAB$ + GetShortcutText(#ShortcutValue_BalloonTooltips))
    MenuItem(#MenuBar_Keeper_ColourBand,        ShortTooltip\ColourBand        + #TAB$ + GetShortcutText(#ShortcutValue_ColourBand))
    MenuItem(#MenuBar_Keeper_HideDetail,        ShortTooltip\HideDetail        + #TAB$ + GetShortcutText(#ShortcutValue_HideDetail))
    MenuItem(#MenuBar_Keeper_MessageSave,       ShortTooltip\MessageSave       + #TAB$ + GetShortcutText(#ShortcutValue_MessageSave))
    MenuItem(#MenuBar_Keeper_ShowToolbar,       ShortTooltip\ShowToolbar       + #TAB$ + GetShortcutText(#ShortcutValue_ShowToolbar))
    MenuItem(#MenuBar_Keeper_ScreenSnap,        ShortTooltip\Screensnap        + #TAB$ + GetShortcutText(#ShortcutValue_Screensnap))
    MenuItem(#MenuBar_Keeper_StickyWindow,      ShortTooltip\Stickywindow      + #TAB$ + GetShortcutText(#ShortcutValue_Stickywindow))
    MenuItem(#MenuBar_Keeper_TitleClock,        ShortTooltip\Titleclock        + #TAB$ + GetShortcutText(#ShortcutValue_Titleclock))
    MenuTitle("Help")
    MenuItem(#MenuBar_Keeper_AboutProgram,      ShortTooltip\AboutProgram      + #TAB$ + GetShortcutText(#ShortcutValue_AboutProgram),      ImageID(#MenuBarIcon_Keeper_AboutProgram))
    MenuItem(#MenuBar_Keeper_KeyboardShortcuts, ShortTooltip\KeyboardShortcuts + #TAB$ + GetShortcutText(#ShortcutValue_KeyboardShortcuts), ImageID(#MenuBarIcon_Keeper_KeyboardShortcuts))
    MenuItem(#MenuBar_Keeper_ProgramHelp,       ShortTooltip\ProgramHelp       + #TAB$ + GetShortcutText(#ShortcutValue_ProgramHelp),       ImageID(#MenuBarIcon_Keeper_ProgramHelp))
    MenuItem(#MenuBar_Keeper_ViewLog,           ShortTooltip\ViewLog           + #TAB$ + GetShortcutText(#ShortcutValue_ViewLog),           ImageID(#MenuBarIcon_Keeper_ViewLog))
  Else
    MessageRequester("Menu Creation Error", "Could not create the main system menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; Create the Category bar popup menu
  ;------------------------------------------------------------------------------------------------

  If CreatePopupImageMenu(#PopMenuBar_Category)
    MenuItem(#PopMenuBar_Category_AddCategory,      FormatMenu(ShortTooltip\AddCategory,           GetShortcutText(#ShortcutValue_AddCategory),           45),  ImageID(#MenuBarIcon_Keeper_AddCategory))
    MenuItem(#PopMenuBar_Category_CopyCategory,     FormatMenu(ShortTooltip\CopyCategory,          GetShortcutText(#ShortcutValue_CopyCategory),          45),  ImageID(#MenuBarIcon_Keeper_CopyCategory))
    MenuItem(#PopMenuBar_Category_DeleteCategory,   FormatMenu(ShortTooltip\DeleteCategory,        GetShortcutText(#ShortcutValue_DeleteCategory),        45),  ImageID(#MenuBarIcon_Keeper_DeleteCategory))
    MenuItem(#PopMenuBar_Category_EditCategory,     FormatMenu(ShortTooltip\EditCategory,          GetShortcutText(#ShortcutValue_EditCategory),          45),  ImageID(#MenuBarIcon_Keeper_EditCategory))
    MenuBar()
    MenuItem(#PopMenuBar_Category_ExportCategories, FormatMenu(ShortTooltip\ExportCategories,      GetShortcutText(#ShortcutValue_ExportCategories),      45),  ImageID(#MenuBarIcon_Keeper_ExportCategories))
    MenuItem(#PopMenuBar_Category_ImportCategories, FormatMenu(ShortTooltip\ImportCategories,      GetShortcutText(#ShortcutValue_ImportCategories),      45),  ImageID(#MenuBarIcon_Keeper_ImportCategories))
  Else
    MessageRequester("Category menu", "Could not create the category popup menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Create the main program popupmenu
  ;------------------------------------------------------------------------------------------------
  
  If CreatePopupImageMenu(#PopMenuBar_Keeper)
    ;MenuTitle("Files")
    MenuItem(#PopMenuBar_Keeper_BackupDatabase,    ShortTooltip\BackupDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_BackupDatabase),    ImageID(#MenuBarIcon_Keeper_BackupDatabase))
    MenuItem(#PopMenuBar_Keeper_ExportDatabase,    ShortTooltip\ExportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ExportDatabase),    ImageID(#MenuBarIcon_Keeper_ExportDatabase))
    MenuItem(#PopMenuBar_Keeper_ImportDatabase,    ShortTooltip\ImportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ImportDatabase),    ImageID(#MenuBarIcon_Keeper_ImportDatabase))
    MenuItem(#PopMenuBar_Keeper_VacuumDatabase,    ShortTooltip\VacuumDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_VacuumDatabase),    ImageID(#MenuBarIcon_Keeper_VacuumDatabase))
    MenuItem(#PopMenuBar_Keeper_ExitProgram,       ShortTooltip\ExitProgram       + #TAB$ + GetShortcutText(#ShortcutValue_ExitProgram),       ImageID(#MenuBarIcon_Keeper_ExitProgram))
    ;MenuTitle("Data")
    MenuBar()
    MenuItem(#PopMenuBar_Keeper_AddItem,           ShortTooltip\AddItem           + #TAB$ + GetShortcutText(#ShortcutValue_AddItem),           ImageID(#MenuBarIcon_Keeper_AddItem))
    MenuItem(#PopMenuBar_Keeper_ArchiveItem,       ShortTooltip\ArchiveItem       + #TAB$ + GetShortcutText(#ShortcutValue_ArchiveItem),       ImageID(#MenuBarIcon_Keeper_ArchiveItem))
    MenuItem(#PopMenuBar_Keeper_AttachItem,        ShortTooltip\AttachItem        + #TAB$ + GetShortcutText(#ShortcutValue_AttachItem),        ImageID(#MenuBarIcon_Keeper_AttachItem))
    MenuItem(#PopMenuBar_Keeper_CopyItem,          ShortTooltip\CopyItem          + #TAB$ + GetShortcutText(#ShortcutValue_CopyItem),          ImageID(#MenuBarIcon_Keeper_CopyItem))
    MenuItem(#PopMenuBar_Keeper_DeleteItem,        ShortTooltip\DeleteItem        + #TAB$ + GetShortcutText(#ShortcutValue_DeleteItem),        ImageID(#MenuBarIcon_Keeper_DeleteItem))
    MenuItem(#PopMenuBar_Keeper_EditItem,          ShortTooltip\EditItem          + #TAB$ + GetShortcutText(#ShortcutValue_EditItem),          ImageID(#MenuBarIcon_Keeper_EditItem))
    MenuItem(#PopMenuBar_Keeper_ExportItem,        ShortTooltip\Exportitem        + #TAB$ + GetShortcutText(#ShortcutValue_ExportItem),        ImageID(#MenuBarIcon_Keeper_ExportItem))
    MenuItem(#PopMenuBar_Keeper_FavouriteItem,     ShortTooltip\FavouriteItem     + #TAB$ + GetShortcutText(#ShortcutValue_FavouriteItem),     ImageID(#MenuBarIcon_Keeper_FavouriteItem))
    MenuItem(#PopMenuBar_Keeper_ImportItem,        ShortTooltip\ImportItem        + #TAB$ + GetShortcutText(#ShortcutValue_ImportItem),        ImageID(#MenuBarIcon_Keeper_ImportItem))
    MenuItem(#PopMenuBar_Keeper_KillItem,          ShortTooltip\KillItem          + #TAB$ + GetShortcutText(#ShortcutValue_KillItem),          ImageID(#MenuBarIcon_Keeper_KillItem))
    MenuItem(#PopMenuBar_Keeper_LockItem,          ShortTooltip\LockItem          + #TAB$ + GetShortcutText(#ShortcutValue_LockItem),          ImageID(#MenuBarIcon_Keeper_LockItem))
    MenuItem(#PopMenuBar_Keeper_PrintItem,         ShortTooltip\PrintItem         + #TAB$ + GetShortcutText(#ShortcutValue_PrintItem),         ImageID(#MenuBarIcon_Keeper_PrintItem))
    ;MenuTitle("Utilities")
    MenuBar()
    MenuItem(#PopMenuBar_Keeper_AdvancedSearch,    ShortTooltip\AdvancedSearch    + #TAB$ + GetShortcutText(#ShortcutValue_AdvancedSearch),    ImageID(#MenuBarIcon_Keeper_AdvancedSearch))
    MenuItem(#PopMenuBar_Keeper_SelectAllItems,    ShortTooltip\SelectAllItems    + #TAB$ + GetShortcutText(#ShortcutValue_SelectAllItems),    ImageID(#MenuBarIcon_Keeper_SelectAllItems))
    MenuItem(#PopMenuBar_Keeper_OwnerManagement,   ShortTooltip\OwnerManagement   + #TAB$ + GetShortcutText(#ShortcutValue_OwnerManagement),   ImageID(#MenuBarIcon_Keeper_OwnerManagement))
    MenuItem(#PopMenuBar_Keeper_EditPassword,      ShortTooltip\EditPassword      + #TAB$ + GetShortcutText(#ShortcutValue_EditPassword),      ImageID(#MenuBarIcon_Keeper_EditPassword))
    MenuItem(#PopMenuBar_Keeper_LockProgram,       ShortTooltip\LockProgram       + #TAB$ + GetShortcutText(#ShortcutValue_LockProgram),       ImageID(#MenuBarIcon_Keeper_LockProgram))
    ;MenuTitle("Options")
    MenuBar()
    MenuItem(#PopMenuBar_Keeper_BalloonTooltips,   ShortTooltip\BalloonTooltips   + #TAB$ + GetShortcutText(#ShortcutValue_BalloonTooltips))
    MenuItem(#PopMenuBar_Keeper_ColourBand,        ShortTooltip\ColourBand        + #TAB$ + GetShortcutText(#ShortcutValue_ColourBand))
    MenuItem(#PopMenuBar_Keeper_HideDetail,        ShortTooltip\HideDetail        + #TAB$ + GetShortcutText(#ShortcutValue_HideDetail))
    MenuItem(#PopMenuBar_Keeper_MessageSave,       ShortTooltip\MessageSave       + #TAB$ + GetShortcutText(#ShortcutValue_MessageSave))
    MenuItem(#PopMenuBar_Keeper_ShowToolbar,       ShortTooltip\ShowToolbar       + #TAB$ + GetShortcutText(#ShortcutValue_ShowToolbar))
    MenuItem(#PopMenuBar_Keeper_ScreenSnap,        ShortTooltip\Screensnap        + #TAB$ + GetShortcutText(#ShortcutValue_Screensnap))
    MenuItem(#PopMenuBar_Keeper_StickyWindow,      ShortTooltip\Stickywindow      + #TAB$ + GetShortcutText(#ShortcutValue_Stickywindow))
    MenuItem(#PopMenuBar_Keeper_TitleClock,        ShortTooltip\Titleclock        + #TAB$ + GetShortcutText(#ShortcutValue_Titleclock))
    ;MenuTitle("Help")
    MenuBar()
    MenuItem(#PopMenuBar_Keeper_AboutProgram,      ShortTooltip\AboutProgram      + #TAB$ + GetShortcutText(#ShortcutValue_AboutProgram),      ImageID(#MenuBarIcon_Keeper_AboutProgram))
    MenuItem(#PopMenuBar_Keeper_KeyboardShortcuts, ShortTooltip\KeyboardShortcuts + #TAB$ + GetShortcutText(#ShortcutValue_KeyboardShortcuts), ImageID(#MenuBarIcon_Keeper_KeyboardShortcuts))
    MenuItem(#PopMenuBar_Keeper_ProgramHelp,       ShortTooltip\ProgramHelp       + #TAB$ + GetShortcutText(#ShortcutValue_ProgramHelp),       ImageID(#MenuBarIcon_Keeper_ProgramHelp))
    MenuItem(#PopMenuBar_Keeper_ViewLog,           ShortTooltip\ViewLog           + #TAB$ + GetShortcutText(#ShortcutValue_ViewLog),           ImageID(#MenuBarIcon_Keeper_ViewLog))
  Else
    MessageRequester("Popup Menu Creation Error", "Could not create the main system popup menu, only form buttons will be available.", #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Popup menu for the editor gadget on the data form
  ;------------------------------------------------------------------------------------------------
  
  If CreatePopupImageMenu(#PopMenubar_Details, #PB_Menu_ModernLook)
    MenuItem(#PopMenubar_Details_CopyItem,  FormatMenu(ShortTooltip\CopyItem,  GetShortcutText(#ShortcutValue_CopyItem),   45),  ImageID(#MenuBarIcon_Keeper_CopyItem))
    MenuItem(#PopMenuBar_Details_EditItem,  FormatMenu(ShortTooltip\EditItem,  GetShortcutText(#ShortcutValue_EditItem),   45),  ImageID(#MenuBarIcon_Keeper_EditItem))
    MenuItem(#PopMenuBar_Details_PrintItem, FormatMenu(ShortTooltip\PrintItem, GetShortcutText(#ShortcutValue_PrintItem),  45),  ImageID(#MenuBarIcon_Keeper_PrintItem))
  Else
    MessageRequester("Main menu", "Could not create image popup menu for detail pane, no menu functions will be available.", #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Add all keyboard shortcuts to the main form
  ;------------------------------------------------------------------------------------------------
  
  ; Files
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_BackupDatabase,    #KeyboardShortcut_BackupDatabase)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ExportDatabase,    #KeyboardShortcut_ExportDatabase)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ImportDatabase,    #KeyboardShortcut_ImportDatabase)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_VacuumDatabase,    #KeyboardShortcut_VacuumDatabase)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ExitProgram,       #KeyboardShortcut_ExitProgram)
  ; Categories
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_AddCategory,       #KeyboardShortcut_AddCategory)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_CopyCategory,      #KeyboardShortcut_CopyCategory)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_DeleteCategory,    #KeyboardShortcut_DeleteCategory)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_EditCategory,      #KeyboardShortcut_EditCategory)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ExportCategories,  #KeyboardShortcut_ExportCategories)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ImportCategories,  #KeyboardShortcut_ImportCategories)
  ; Data
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_AddItem,           #KeyboardShortcut_AddItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ArchiveItem,       #KeyboardShortcut_ArchiveItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_AttachItem,        #KeyboardShortcut_AttachItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_CopyItem,          #KeyboardShortcut_CopyItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_DeleteItem,        #KeyboardShortcut_DeleteItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_EditItem,          #KeyboardShortcut_EditItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ExportItem,        #KeyboardShortcut_ExportItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_FavouriteItem,     #KeyboardShortcut_FavouriteItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ImportItem,        #KeyboardShortcut_ImportItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_KillItem,          #KeyboardShortcut_KillItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_LockItem,          #KeyboardShortcut_LockItem)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_PrintItem,         #KeyboardShortcut_PrintItem)
  ; Utilities
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_AdvancedSearch,    #KeyboardShortcut_AdvancedSearch)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_SelectAllItems,    #KeyboardShortcut_SelectAllItems)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_OwnerManagement,   #KeyboardShortcut_OwnerManagement)
  ; Options
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ColourBand,        #KeyboardShortcut_BalloonTooltips)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_BalloonTooltips,   #KeyboardShortcut_ColourBand)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_HideDetail,        #KeyboardShortcut_HideDetail)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_MessageSave,       #KeyboardShortcut_MessageSave)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ShowToolbar,       #KeyboardShortcut_ShowToolbar)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ScreenSnap,        #KeyboardShortcut_ScreenSnap)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_StickyWindow,      #KeyboardShortcut_StickyWindow)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_TitleClock,        #KeyboardShortcut_TitleClock)
  ; Help
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_AboutProgram,      #KeyboardShortcut_AboutProgram)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_KeyboardShortcuts, #KeyboardShortcut_KeyboardShortcuts)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ProgramHelp,       #KeyboardShortcut_ProgramHelp)
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_ViewLog,           #KeyboardShortcut_ViewLog)
  ; Basic searching
  AddKeyboardShortcut(#Window_Keeper, #ShortcutValue_CheckEnter,        #KeyboardShortcut_CheckEnter)
  
  ;------------------------------------------------------------------------------------------------
  ; Remove borders from gadgets
  ;------------------------------------------------------------------------------------------------
  
  ;   RemoveBorders(#Gadget_Keeper_Category)
  ;   RemoveBorders(#Gadget_Keeper_Titles)
  ;   RemoveBorders(#Gadget_Keeper_Information)
  
  ;------------------------------------------------------------------------------------------------
  ; Turn on mouse event hover testing, this is NetMaestro's code.
  ;------------------------------------------------------------------------------------------------
  
  InitHoverEvents(#Window_Keeper)
  
  ;------------------------------------------------------------------------------------------------
  ; Add main form gadgets to the hoverable list
  ;------------------------------------------------------------------------------------------------
  
  AddHoverGadget(GadgetID(#Gadget_Keeper_Add))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Archive))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Attach))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Copy))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Delete))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Edit))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Export))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Favourite))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Import))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Kill))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Lock))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Print))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Search))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Help))
  AddHoverGadget(GadgetID(#Gadget_Keeper_Exit))
  
  ;------------------------------------------------------------------------------------------------
  ; Balloon tooltips with keyboard shortcut display
  ;------------------------------------------------------------------------------------------------
  
  If Program\BalloonFontId
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Add,        Program\BalloonFontId, $FFFFFF, ShortTooltip\AddItem,         #CRLF$ + GetShortCutText(#ShortcutValue_AddItem)        + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\AddItem,        30),  GetIconHandle(#Image_Keeper_Add))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Archive,    Program\BalloonFontId, $FFFFFF, ShortTooltip\ArchiveItem,     #CRLF$ + GetShortCutText(#ShortcutValue_ArchiveItem)    + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ArchiveItem,    30),  GetIconHandle(#Image_Keeper_Archive))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Attach,     Program\BalloonFontId, $FFFFFF, ShortTooltip\AttachItem,      #CRLF$ + GetShortCutText(#ShortcutValue_AttachItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\AttachItem,     30),  GetIconHandle(#Image_Keeper_Attach))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Copy,       Program\BalloonFontId, $FFFFFF, ShortTooltip\CopyItem,        #CRLF$ + GetShortCutText(#ShortcutValue_CopyItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\CopyItem,       30),  GetIconHandle(#Image_Keeper_Copy))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Delete,     Program\BalloonFontId, $FFFFFF, ShortTooltip\DeleteItem,      #CRLF$ + GetShortCutText(#ShortcutValue_DeleteItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\DeleteItem,     30),  GetIconHandle(#Image_Keeper_Delete))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Edit,       Program\BalloonFontId, $FFFFFF, ShortTooltip\EditItem,        #CRLF$ + GetShortCutText(#ShortcutValue_EditItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\EditItem,       30),  GetIconHandle(#Image_Keeper_Edit))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Export,     Program\BalloonFontId, $FFFFFF, ShortTooltip\ExportItem,      #CRLF$ + GetShortCutText(#ShortcutValue_ExportItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ExportItem,     30),  GetIconHandle(#Image_Keeper_Export))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Favourite,  Program\BalloonFontId, $FFFFFF, ShortTooltip\FavouriteItem,   #CRLF$ + GetShortCutText(#ShortcutValue_FavouriteItem)  + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\FavouriteItem,  30),  GetIconHandle(#Image_Keeper_Favourite))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Import,     Program\BalloonFontId, $FFFFFF, ShortTooltip\ImportItem,      #CRLF$ + GetShortCutText(#ShortcutValue_ImportItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ImportItem,     30),  GetIconHandle(#Image_Keeper_Import))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Kill,       Program\BalloonFontId, $FFFFFF, ShortTooltip\KillItem,        #CRLF$ + GetShortCutText(#ShortcutValue_KillItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\KillItem,       30),  GetIconHandle(#Image_Keeper_Kill))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Lock,       Program\BalloonFontId, $FFFFFF, ShortTooltip\LockItem,        #CRLF$ + GetShortCutText(#ShortcutValue_LockItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\LockItem,       30),  GetIconHandle(#Image_Keeper_Lock))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Print,      Program\BalloonFontId, $FFFFFF, ShortTooltip\PrintItem,       #CRLF$ + GetShortCutText(#ShortcutValue_PrintItem)      + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\PrintItem,      30),  GetIconHandle(#Image_Keeper_Print))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Search,     Program\BalloonFontId, $FFFFFF, ShortTooltip\AdvancedSearch,  #CRLF$ + GetShortCutText(#ShortcutValue_AdvancedSearch) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\AdvancedSearch, 30),  GetIconHandle(#Image_Keeper_Search))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Help,       Program\BalloonFontId, $FFFFFF, ShortTooltip\ProgramHelp,     #CRLF$ + GetShortCutText(#ShortcutValue_ProgramHelp)    + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ProgramHelp,    30),  GetIconHandle(#Image_Keeper_Help))
    BalloonToolTip(#Window_Keeper, #Gadget_Keeper_Exit,       Program\BalloonFontId, $FFFFFF, ShortTooltip\ExitProgram,     #CRLF$ + GetShortCutText(#ShortcutValue_ExitProgram)    + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ExitProgram,    30),  GetIconHandle(#Image_Keeper_Exit))
  Else
    MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Load a strikeout font to be used on the item list when an item is marked as deleted
  ;------------------------------------------------------------------------------------------------
  
  CurrentFont.i     = GetGadgetFont(#Gadget_Keeper_Titles)                          ; Get current font
  GetObject_(CurrentFont.i, SizeOf(LOGFONT), @logf.LOGFONT)
  mFontName.s       = PeekS(@logf\lfFacename[0])
  hDEviceContext    = CreateDC_(@"DISPLAY", 0, 0, 0)
  LogPixSY          = GetDeviceCaps_(hDEviceContext, #LOGPIXELSY)
  DeleteDC_(hDEviceContext)
  mFontsize.F       = - (logf\lfHeight * 72) / LogPixSY
  LoadFont(#FontStrikeoutYes, mFontName.s, mFontsize.F, #PB_Font_StrikeOut | #PB_Font_Italic | #PB_Font_HighQuality)  ; Load current font And add strikeout attribute
  LoadFont(#FontStrikeoutNo,  mFontName.s, mFontsize.F, #PB_Font_HighQuality)
  
  ;------------------------------------------------------------------------------------------------
  ; Enable category changing by drag and drop
  ;------------------------------------------------------------------------------------------------
  
  EnableGadgetDrop(#Gadget_Keeper_Category, #PB_Drop_Text, #PB_Drag_Copy)
  
  ;------------------------------------------------------------------------------------------------
  ; Set initial search cue font
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetFont(#Gadget_Keeper_Searchstring, FontID(Cue\SearchCueFont))
  
  ;------------------------------------------------------------------------------------------------
  ; Limit the number of search box characters and set the cue banner text. These variables are set
  ; in the Keeper_Myconstants file.
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(#Gadget_Keeper_Searchstring), #EM_SETLIMITTEXT, 67, 0)
  SendMessage_(GadgetID(#Gadget_Keeper_Searchstring), #EM_SETCUEBANNER,  1,  Cue\SearchCueText)
  
  ;------------------------------------------------------------------------------------------------
  ; Add the search type operators
  ;------------------------------------------------------------------------------------------------
  
  Restore BeginSearchTypes
  
  While TempString.s <> "_EndSearchTypes_"
    Read.s TempString.s
     If TempString.s <> "_EndSearchTypes_"
       AddGadgetItem(#Gadget_Keeper_Searchtype, #AtTheEndOfTheList, TempString.s, ImageID(#Image_ComboSql))
     EndIf
   Wend

   TempString.s = "<>"

  SetGadgetState(#Gadget_Keeper_Searchtype, 0)

  ;------------------------------------------------------------------------------------------------
  ; Add the field selector combo box
  ;------------------------------------------------------------------------------------------------
  
  AddGadgetItem(#Gadget_Keeper_Searchfield, #AtTheEndOfTheList, "All fields",   ImageID(#Image_DataFields))
  
  Restore BeginSqlFields
  
  While TempSqlFields.s <> "_EndSqlFields_"
    Read.s TempSqlFields.s
    If TempSqlFields.s <> "_EndSqlFields_"
      AddGadgetItem(#Gadget_Keeper_Searchfield, #AtTheEndOfTheList, TempSqlFields.s,  ImageID(#Image_DataFields))
    EndIf
  Wend
  
  TempSqlFields.s    = "<>"
  
  SetGadgetState(#Gadget_Keeper_Searchfield, 0)  
  
  ;------------------------------------------------------------------------------------------------
  ; Update the last opened date field. ISO date standard date used
  ;------------------------------------------------------------------------------------------------
  
  VersionUpdate.s                       + 
  "UPDATE Version "                     + 
  "SET LastUpdate = '"                  + 
  FormatDate("%yyyy-%mm-%dd", Date())   + 
  "' "                                  + 
  "WHERE Record = '1'"
  
  If DatabaseUpdate(Program\DatabaseHandle, VersionUpdate.s) <> #DatabaseUpdateFail
    ; Database update version succeeded
  Else
    MessageRequester("Version Update Error", "Could not update the program version number into the database. " + DatabaseError(), #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Turn balloon tooltips on or off for the main form and others
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\BalloonTooltips = #False
    Toggle\BalloonTooltips = #True
  ElseIf Toggle\BalloonTooltips = #True
    Toggle\BalloonTooltips = #False
  EndIf
  
  ToggleBalloonToolTips()
  
  ;------------------------------------------------------------------------------------------------
  ; Turn on or off alternate row colouring in the title list
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\ColourBand = #False
    Toggle\ColourBand = #True
  ElseIf Toggle\ColourBand = #True
    Toggle\ColourBand = #False
  EndIf
  
  ToggleColourBand()
  
  ;------------------------------------------------------------------------------------------------
  ; Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\HideDetail = #False
    Toggle\HideDetail = #True
  ElseIf Toggle\HideDetail = #True
    Toggle\HideDetail = #False
  EndIf
  
  ToggleHideDetail()
  
  ;------------------------------------------------------------------------------------------------
  ; Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\ShowToolbar = #False
    Toggle\ShowToolbar = #True
  ElseIf Toggle\ShowToolbar = #True
    Toggle\ShowToolbar = #False
  EndIf
  
  ToggleWindowToolBars()
  
  ;------------------------------------------------------------------------------------------------
  ; Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\ScreenSnap = #False
    Toggle\ScreenSnap = #True
  ElseIf Toggle\ScreenSnap = #True
    Toggle\ScreenSnap = #False
  EndIf
  
  ToggleScreenSnap()
  
  ;------------------------------------------------------------------------------------------------
  ; Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\StickyWindow = #False
    Toggle\StickyWindow = #True
  ElseIf Toggle\StickyWindow = #True
    Toggle\StickyWindow = #False
  EndIf
  
  ToggleStickyWindow()
  
  ;------------------------------------------------------------------------------------------------
  ; Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\TitleClock = #False
    Toggle\TitleClock = #True
  ElseIf Toggle\TitleClock = #True
    Toggle\TitleClock = #False
  EndIf
  
  ToggleTitleBarClock()
  
  ;------------------------------------------------------------------------------------------------
  ; Choose to show messages after saving data
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\MessageSave = #False
    Toggle\MessageSave = #True
  ElseIf Toggle\MessageSave = #True
    Toggle\MessageSave = #False
  EndIf
  
  ToggleTitleBarClock()
  
  ;------------------------------------------------------------------------------------------------
  ; Set the initial program quit flag
  ;------------------------------------------------------------------------------------------------
  
  Program\QuitValue = #False
  
  ;------------------------------------------------------------------------------------------------
  ; Set a marker for first time only operations
  ;------------------------------------------------------------------------------------------------
  
  Program\FirstTime = #False
  
  ;------------------------------------------------------------------------------------------------
  ; Set the last used display search limit
  ;------------------------------------------------------------------------------------------------
  
  If Program\SearchLimit  <>  #Empty$
    SetGadgetText(#Gadget_Keeper_SearchLimit, Program\SearchLimit)
  Else
    SetGadgetText(#Gadget_Keeper_SearchLimit, "25")
    Program\SearchLimit = "25"
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; Set the last used search string
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_Keeper_Searchstring, Program\LastSearch)
  
  ;------------------------------------------------------------------------------------------------
  ; Now display all the categories available
  ;------------------------------------------------------------------------------------------------
  
  LoadCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; Set the fake statusbar heading appropriate for the run time of the program
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.s = CountRecords("Record", "Keeper")
  
  If NumberOfItems.s = "0"
    SetInfoBarArea("Headings",  "Welcome",  "Program " + #Program + " is ready to go.", "MainModule")
    SetInfoBarArea("Number",    "",         "?", "MainModule")
    SetInfoBarArea("Records",   "",         "0", "MainModule")
  ElseIf NumberOfItems.s <> "0"
    SetGadgetState(#Gadget_Keeper_Titles, 0)
    PostEvent(#PB_Event_Gadget, #Window_Keeper, #Gadget_Keeper_Titles, #PB_EventType_Change)
    SetInfoBarArea("Headings",  "Welcome",  "Welcome to Keeper " + #Image_ProgramIcon, "MainModule")
    SetInfoBarArea("Records",   "",         NumberOfItems.s, "MainModule")
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Set focus on the search bar
  ;------------------------------------------------------------------------------------------------
  
  SetActiveGadget(#Gadget_Keeper_Searchstring)
  
  ;------------------------------------------------------------------------------------------------
  ; Unhide the main program window
  ;------------------------------------------------------------------------------------------------
  
  HideWindow(#Window_Keeper, #False)
  
  ;------------------------------------------------------------------------------------------------
  ; Start main form event processing
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    EventID  = WaitWindowEvent()
    MenuID   = EventMenu()
    GadgetID = EventGadget()
    WindowID = EventWindow()
    
    ;----------------------------------------------------------------------------------------------
    ; All window closing events
    ;----------------------------------------------------------------------------------------------
    
    Select EventID
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
        
      Case #PB_Event_CloseWindow
        
        Select WindowID
            
          ;----------------------------------------------------------------------------------------
          ; Security windows
          ;----------------------------------------------------------------------------------------

          Case #Window_StartUpPassword                                                                                                    : Program\QuitValue = #True
          Case #Window_EditPassword                                                                                                       : CloseMyWindow(#Window_EditPassword)
          Case #Window_UnlockPassword                                                                                                     : Program\QuitValue = #True
          Case #Window_NewPassword                                                                                                        : Program\QuitValue = #True
            
          ;----------------------------------------------------------------------------------------
          ; Normal windows
          ;----------------------------------------------------------------------------------------
            
          Case #Window_Keeper                                                                                                             : Program\QuitValue.i = #True
          Case #Window_Category                                                                                                           : CloseMyWindow(#Window_Category)
          Case #Window_Data                                                                                                               : CloseMyWindow(#Window_Data)
          Case #Window_Search                                                                                                             : CloseMyWindow(#Window_Search)
          Case #Window_OwnerList                                                                                                          : CloseMyWindow(#Window_OwnerList)
          Case #Window_Owner                                                                                                              : CloseMyWindow(#Window_Owner)
          Case #Window_Print                                                                                                              : CloseMyWindow(#Window_Print)
          Case #Window_About                                                                                                              : CloseMyWindow(#Window_About)
          Case #Window_Help                                                                                                               : CloseMyWindow(#Window_Help)
          Case #Window_Shortcuts                                                                                                          : CloseMyWindow(#Window_Shortcuts)
          Case #Window_Errorlog                                                                                                           : CloseMyWindow(#Window_Errorlog)
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; Minimise the program to the windows tray and set icon and tooltip
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_MinimizeWindow
        
        Select EventWindow()
          Case #Window_Keeper                                                                                                             : HideProgramWindow()
        EndSelect

        ;------------------------------------------------------------------------------------------
        ; Wife says banner looks childish (Heheheh)
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_SizeWindow
        Select WindowID
          Case #Window_Keeper                                                                                                             : 
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_GadgetDrop
        Select EventDropType()
          Case #PB_Drop_Text
            Select GadgetID
              Case #Gadget_Keeper_Category                                                                                                : ChangeCategory()
            EndSelect
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; All menu and keyboard shortcut events
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_Menu
        
        Select MenuID

          ; Password editing
          
          Case #KeyboardShortCut_EditPassword_Return                                                                                      : CheckPassWords()
          Case #KeyboardShortCut_EditPassword_Escape                                                                                      : CloseMyWindow(#Window_EditPassword)

          ; Program unlocking

          Case #KeyboardShortCut_UnlockPassword_Return                                                                                    : CheckUnlockPassWord()
          Case #KeyboardShortCut_UnlockPassword_Escape                                                                                    : Program\QuitValue.i = #True
            
          Case #PopMenuBar_Keeper_EditPassword,         #MenuBar_Keeper_EditPassword                                                      : EditPassWordWindow()
          Case #PopMenuBar_Keeper_LockProgram,          #MenuBar_Keeper_LockProgram                                                       : LockProgramWindow()
          
          ; Files menu

          Case #PopMenuBar_Keeper_BackupDatabase,       #MenuBar_Keeper_BackupDatabase,        #KeyboardShortcut_BackupDatabase           : BackupDatabase()
          Case #PopMenuBar_Keeper_ExportDatabase,       #MenuBar_Keeper_ExportDatabase,        #KeyboardShortcut_ExportDatabase           : ExportDatabase()
          Case #PopMenuBar_Keeper_ImportDatabase,       #MenuBar_Keeper_ImportDatabase,        #KeyboardShortcut_ImportDatabase           : ImportDatabase()
          Case #PopMenuBar_Keeper_VacuumDatabase,       #MenuBar_Keeper_VacuumDatabase,        #KeyboardShortcut_VacuumDatabase           : VacuumDeletedData()
          Case #PopMenuBar_Keeper_ExitProgram,          #MenuBar_Keeper_ExitProgram,           #KeyboardShortcut_ExitProgram              : Program\QuitValue.i = #True
            
          ; Categories menu
            
          Case #PopMenuBar_Category_AddCategory,        #MenuBar_Keeper_AddCategory,           #KeyboardShortcut_AddCategory              : AddCategory()
          Case #PopMenuBar_Category_CopyCategory,       #MenuBar_Keeper_CopyCategory,          #KeyboardShortcut_CopyCategory             : CopyCategory()
          Case #PopMenuBar_Category_DeleteCategory,     #MenuBar_Keeper_DeleteCategory,        #KeyboardShortcut_DeleteCategory           : DeleteCategory()
          Case #PopMenuBar_Category_EditCategory,       #MenuBar_Keeper_EditCategory,          #KeyboardShortcut_EditCategory             : EditCategory()
          Case #PopMenuBar_Category_ExportCategories,   #MenuBar_Keeper_ExportCategories,      #KeyboardShortcut_ExportCategories         : ExportCategories()
          Case #PopMenuBar_Category_ImportCategories,   #MenuBar_Keeper_ImportCategories,      #KeyboardShortcut_ImportCategories         : ImportCategories()

          ; Data menu
            
          Case #PopMenuBar_Keeper_AddItem,              #MenuBar_Keeper_AddItem,              #KeyboardShortcut_AddItem                   : AddNewData()
          Case #PopMenuBar_Keeper_ArchiveItem,          #MenuBar_Keeper_ArchiveItem,          #KeyboardShortcut_ArchiveItem               : ArchiveThisData()
          Case #PopMenuBar_Keeper_AttachItem,           #MenuBar_Keeper_AttachItem,           #KeyboardShortcut_AttachItem                : AttachItemToData()
          Case #PopMenuBar_Keeper_CopyItem,             #MenuBar_Keeper_CopyItem,             #KeyboardShortcut_CopyItem                  : CopyDataToClipboard()
          Case #PopMenuBar_Keeper_DeleteItem,           #MenuBar_Keeper_DeleteItem,           #KeyboardShortcut_DeleteItem                : DeleteCurrentData()
          Case #PopMenuBar_Keeper_EditItem,             #MenuBar_Keeper_EditItem,             #KeyboardShortcut_EditItem                  : EditOldData()
          Case #PopMenuBar_Keeper_ExportItem,           #MenuBar_Keeper_ExportItem,           #KeyboardShortcut_ExportItem                : ExportItemToDisk()
          Case #PopMenuBar_Keeper_FavouriteItem,        #MenuBar_Keeper_FavouriteItem,        #KeyboardShortcut_FavouriteItem             : MarkAsFavourite()
          Case #PopMenuBar_Keeper_ImportItem,           #MenuBar_Keeper_ImportItem,           #KeyboardShortcut_ImportItem                : ImportItemFromDisk()
          Case #PopMenuBar_Keeper_KillItem,             #MenuBar_Keeper_KillItem,             #KeyboardShortcut_KillItem                  : KillCurrentData()
          Case #PopMenuBar_Keeper_LockItem,             #MenuBar_Keeper_LockItem,             #KeyboardShortcut_LockItem                  : LockCurrentData()
          Case #PopMenuBar_Keeper_PrintItem,            #MenuBar_Keeper_PrintItem,            #KeyboardShortcut_PrintItem                 : PrintThisData()
            
          ; Utilities menu
            
          Case #PopMenuBar_Keeper_AdvancedSearch,       #MenuBar_Keeper_AdvancedSearch,       #KeyboardShortcut_AdvancedSearch            : AdvancedSearch()
          Case #PopMenuBar_Keeper_SelectAllItems,       #MenuBar_Keeper_SelectAllItems,       #KeyboardShortcut_SelectAllItems            : SelectAllItems() 
          Case #PopMenuBar_Keeper_OwnerManagement,      #MenuBar_Keeper_OwnerManagement,      #KeyboardShortcut_OwnerManagement           : ManageOwners()
            
          ; Options menu
            
          Case #PopMenuBar_Keeper_BalloonTooltips,      #MenuBar_Keeper_BalloonTooltips,      #KeyboardShortcut_BalloonTooltips           : ToggleBalloonToolTips()
          Case #PopMenuBar_Keeper_ColourBand,           #MenuBar_Keeper_ColourBand,           #KeyboardShortcut_ColourBand                : ToggleColourBand()
          Case #PopMenuBar_Keeper_HideDetail,           #MenuBar_Keeper_HideDetail,           #KeyboardShortcut_HideDetail                : ToggleHideDetail()
          Case #PopMenuBar_Keeper_MessageSave,          #MenuBar_Keeper_MessageSave,          #KeyboardShortcut_MessageSave               : ToggleMessageSave()
          Case #PopMenuBar_Keeper_ShowToolbar,          #MenuBar_Keeper_ShowToolBar,          #KeyboardShortcut_ShowToolbar               : ToggleWindowToolbars()
          Case #PopMenuBar_Keeper_ScreenSnap,           #MenuBar_Keeper_ScreenSnap,           #KeyboardShortcut_ScreenSnap                : ToggleScreenSnap()
          Case #PopMenuBar_Keeper_StickyWindow,         #MenuBar_Keeper_StickyWindow,         #KeyboardShortcut_StickyWindow              : ToggleStickyWindow()
          Case #PopMenuBar_Keeper_TitleClock,           #MenuBar_Keeper_TitleClock,           #KeyboardShortcut_TitleClock                : ToggleTitlebarClock()
            
          ; Help menu
            
          Case #PopMenuBar_Keeper_AboutProgram,         #MenuBar_Keeper_AboutProgram,         #KeyboardShortcut_AboutProgram              : AboutKeeper()
          Case #PopMenuBar_Keeper_KeyboardShortcuts,    #MenuBar_Keeper_KeyboardShortcuts,    #KeyboardShortcut_KeyboardShortcuts         : KeyboardShortcuts()
          Case #PopMenuBar_Keeper_ProgramHelp,          #MenuBar_Keeper_ProgramHelp,          #KeyboardShortcut_ProgramHelp               : ShowHelp("MainForm")
          Case #PopMenuBar_Keeper_ViewLog,              #MenuBar_Keeper_ViewLog,              #KeyboardShortcut_ViewLog                   : ViewErrorLog()
            
          ; Basic searching
            
          Case #KeyboardShortcut_CheckEnter                                                                                               : CheckEnterGadget()
            
          ;----------------------------------------------------------------------------------------
          ; Category form shortcuts
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveCategory                                                                                             : SaveCategory()
          Case #KeyboardShortcut_HelpCategory                                                                                             : ShowHelp("Category")
          Case #KeyboardShortcut_ExitCategory,          #KeyboardShortcut_EscapeCategory                                                  : CloseMyWindow(#Window_Category)
            
          ;----------------------------------------------------------------------------------------
          ; Data editor shortcuts
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveData                                                                                                 : SaveThisData()
          Case #KeyboardShortcut_ExportData                                                                                               : ; ExportData()
          Case #KeyboardShortcut_ImportData                                                                                               : ; ImportData()
          Case #KeyboardShortcut_HelpData                                                                                                 : ShowHelp("DataForm")
          Case #KeyboardShortcut_ExitData,             #KeyboardShortcut_EscapeData                                                       : CloseMyWindow(#Window_Data)
          Case #KeyboardShortcut_SearchData                                                                                               : SearchData()
            
          ;----------------------------------------------------------------------------------------
          ; Advanced search form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_ReturnSearch                                                                                             : AdvancedSearchNow()
          Case #KeyboardShortcut_RunSearch                                                                                                : AdvancedSearchNow()
          Case #KeyboardShortcut_HelpSearch                                                                                               : ShowHelp("SearchForm")
          Case #KeyboardShortcut_ExitSearch,          #KeyboardShortcut_EscapeSearch                                                      : CloseMyWindow(#Window_Search)

          ;----------------------------------------------------------------------------------------
          ; Owner list form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveOwnerlist                                                                                            : CloseMyWindow(#Window_OwnerList)
          Case #KeyboardShortcut_AddOwnerlist                                                                                             : AddOwner()
          Case #KeyboardShortcut_DeleteOwnerlist                                                                                          : DeleteOwner()
          Case #KeyboardShortcut_EditOwnerlist                                                                                            : EditOwner()
          Case #KeyboardShortcut_HelpOwnerlist                                                                                            : ShowHelp("OwnerListForm")
          Case #KeyboardShortcut_ExitOwnerlist,       #KeyboardShortcut_EscapeOwnerList                                                   : CloseMyWindow(#Window_OwnerList)
            
          ;----------------------------------------------------------------------------------------
          ; Owner editor form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveOwner                                                                                                : SaveOwner()
          Case #KeyboardShortcut_HelpOwner                                                                                                : ShowHelp("OwnerForm")
          Case #KeyboardShortcut_ExitOwner,           #KeyboardShortcut_EscapeOwner                                                       : CloseMyWindow(#Window_Owner)

          ;----------------------------------------------------------------------------------------
          ; Print items form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_NowPrint                                                                                                 : ForceHtmPrint()
          Case #KeyboardShortcut_NowPreview                                                                                               : ForceHtmPreview()
          Case #KeyboardShortcut_ExitPrint,           #KeyboardShortcut_EscapePrint                                                       : CloseMyWindow(#Window_Print)
            
          ;----------------------------------------------------------------------------------------
          ; About program form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_EscapeAbout                                                                                              : CloseMyWindow(#Window_About)
            
          ;----------------------------------------------------------------------------------------
          ; Help display and edit form
          ;----------------------------------------------------------------------------------------
  
          Case #KeyboardShortcut_LoadHelp                                                                                                 : LoadHelp()
          Case #KeyboardShortcut_SaveHelp                                                                                                 : SaveHelp()
          Case #KeyboardShortcut_SearchHelp,          #KeyboardShortcut_SearchOnEnter                                                     : SearchHelp()
          Case #KeyboardShortcut_PrintHelp                                                                                                : PrintHelp()
          Case #KeyboardShortcut_EditHelp                                                                                                 : EditHelp()
          Case #KeyboardShortcut_ExitHelp,            #KeyboardShortcut_EscapeHelp                                                        : CloseMyWindow(#Window_Help)
            
          ;----------------------------------------------------------------------------------------
          ; keyboard shortcut form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_EscapeShortcuts                                                                                          : CloseMyWindow(#Window_Shortcuts)  

          ;----------------------------------------------------------------------------------------
          ; Error log shortcuts form
          ;----------------------------------------------------------------------------------------
          
          Case #KeyboardShortcut_ExitErrorlog                                                                                             : CloseMyWindow(#Window_Errorlog)
          Case #KeyboardShortcut_EscapeErrorlog                                                                                           : CloseMyWindow(#Window_Errorlog)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
            
          Case #PopMenubar_Details_CopyItem                                                                                               : CopyDataToClipboard()
          Case #PopMenuBar_Details_EditItem                                                                                               : EditOldData()
          Case #PopMenuBar_Details_PrintItem                                                                                              : PrintThisData()

        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; All form control events
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_Gadget
        
        Select GadgetID
            
          ;----------------------------------------------------------------------------------------
          ; Category list controls
          ;----------------------------------------------------------------------------------------
            
          Case #Gadget_Keeper_Category
            Select EventType()
              Case #PB_EventType_LeftDoubleClick                                                                                          : EditCategory()
              Case #PB_EventType_RightClick                                                                                               : DisplayPopupMenu(#PopMenuBar_Category, WindowID(#Window_Keeper))
              Case #PB_EventType_Change                                                                                                   : ShowCategory()
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Category form editor controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Category_Category                                                                                                  : MixedStringCase(#Gadget_Category_Category)
            
          Case #Gadget_Category_SaveCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_SaveCategory, "Hovered")                  : StatusBarButtonTip(#Window_Category, "SaveCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_SaveCategory, "Pressed")                  : SaveCategory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_SaveCategory, "Normal")
            EndSelect
            
          Case #Gadget_Category_HelpCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_HelpCategory, "Hovered")                  : StatusBarButtonTip(#Window_Category, "HelpCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_HelpCategory, "Pressed")                  : ShowHelp("CategoryForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_HelpCategory, "Normal")
            EndSelect
            
          Case #Gadget_Category_ExitCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_ExitCategory, "Hovered")                  : StatusBarButtonTip(#Window_Category, "ExitCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_ExitCategory, "Pressed")                  : CloseMyWindow(#Window_Category)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_ExitCategory, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Title list controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Keeper_Titles
            Select EventType()
              Case #PB_EventType_LeftDoubleClick                                                                                          : EditOldData()
              Case #PB_EventType_RightClick                                                                                               : DisplayPopupMenu(#PopMenuBar_Keeper, WindowID(#Window_Keeper))
              Case #PB_EventType_Change                                                                                                   : ShowKeeperData()
              Case #PB_EventType_DragStart                                                                                                : DragToCategory()
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Main form controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Keeper_Add
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Add, "Hovered")                             : StatusBarButtonTip(#Window_Keeper, "AddItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Add, "Pressed")                             : AddNewData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Add, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Archive
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Archive, "Hovered")                         : StatusBarButtonTip(#Window_Keeper, "ArchiveItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Archive, "Pressed")                         : ArchiveThisData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Archive, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Attach
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Attach, "Hovered")                          : StatusBarButtonTip(#Window_Keeper, "AttachItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Attach, "Pressed")                          : AttachItemToData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Attach, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Copy
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Copy, "Hovered")                            : StatusBarButtonTip(#Window_Keeper, "CopyItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Copy, "Pressed")                            : CopyDataToClipboard()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Copy, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Delete
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Delete, "Hovered")                          : StatusBarButtonTip(#Window_Keeper, "DeleteItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Delete, "Pressed")                          : DeleteCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Delete, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Edit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Edit, "Hovered")                            : StatusBarButtonTip(#Window_Keeper, "EditItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Edit, "Pressed")                            : EditOldData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Edit, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Export
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Export, "Hovered")                          : StatusBarButtonTip(#Window_Keeper, "ExportItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Export, "Pressed")                          : ExportItemToDisk()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Export, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Favourite
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Favourite, "Hovered")                       : StatusBarButtonTip(#Window_Keeper, "FavouriteItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Favourite, "Pressed")                       : MarkAsFavourite()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Favourite, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Import
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Import, "Hovered")                          : StatusBarButtonTip(#Window_Keeper, "ImportItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Import, "Pressed")                          : ImportItemFromDisk()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Import, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Kill
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Kill, "Hovered")                            : StatusBarButtonTip(#Window_Keeper, "KillItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Kill, "Pressed")                            : KillCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Kill, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Lock
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Lock, "Hovered")                            : StatusBarButtonTip(#Window_Keeper, "LockItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Lock, "Pressed")                            : LockCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Lock, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Print
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Print, "Hovered")                           : StatusBarButtonTip(#Window_Keeper, "PrintItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Print, "Pressed")                           : PrintThisData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Print, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Search
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Search, "Hovered")                          : StatusBarButtonTip(#Window_Keeper, "SearchItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Search, "Pressed")                          : AdvancedSearch()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Search, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Help
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Help, "Hovered")                            : StatusBarButtonTip(#Window_Keeper, "HelpItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Help, "Pressed")                            : ShowHelp("MainForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Help, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Exit, "Hovered")                            : StatusBarButtonTip(#Window_Keeper, "ExitProgram")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Keeper_Exit, "Pressed")                            : Program\QuitValue.i = #True
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Keeper_Exit, "Normal")
            EndSelect
            
          Case #Gadget_Keeper_SearchLimit
            Select EventType()
              Case #PB_EventType_Change                                                                                                   : Program\SearchLimit = GetGadgetText(#Gadget_Keeper_SearchLimit)
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Data form controls
            ;--------------------------------------------------------------------------------------
          
          Case #Gadget_Data_Title                                                                                                         : StringFirstUpper(#Gadget_Data_Title)
          
          Case #Gadget_Data_Owner
            Select EventType()
              Case #PB_EventType_Change                                                                                                   : MixedComboCaseEx(#Gadget_Data_Owner)
            EndSelect
            
          Case #Gadget_Data_Details
            Select EventType()
              Case #PB_EventType_Change                                                                                                   : ; GetEditorDetails()
            EndSelect
            
          Case #Gadget_Data_SaveData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_SaveData, "Hovered")                          : StatusBarButtonTip(#Window_Data, "SaveData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_SaveData, "Pressed")                          : SaveThisData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_SaveData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_ExportData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_ExportData, "Hovered")                        : StatusBarButtonTip(#Window_Data, "ExportData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_ExportData, "Pressed")                        : Editor_Save(#Gadget_Data_Details, #Empty$)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_ExportData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_ImportData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_ImportData, "Hovered")                        : StatusBarButtonTip(#Window_Data, "ImportData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_ImportData, "Pressed")                        : Editor_Load(#Gadget_Data_Details, #Empty$)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_ImportData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_HelpData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_HelpData, "Hovered")                          : StatusBarButtonTip(#Window_Data, "HelpData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_HelpData, "Pressed")                          : ShowHelp("DataForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_HelpData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_ExitData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_ExitData, "Hovered")                          : StatusBarButtonTip(#Window_Data, "ExitData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_ExitData, "Pressed")                          : CloseMyWindow(#Window_Data)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_ExitData, "Normal")   
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Advanced search form controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Search_RunSearch
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Search_RunSearch, "Hovered")                       : StatusBarButtonTip(#Window_Data, "RunSearch")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Search_RunSearch, "Pressed")                       : AdvancedSearchNow()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Search_RunSearch, "Normal")   
            EndSelect
            
          Case #Gadget_Search_HelpSearch
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Search_HelpSearch, "Hovered")                      : StatusBarButtonTip(#Window_Data, "HelpSearch")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Search_HelpSearch, "Pressed")                      : ShowHelp("SearchForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Search_HelpSearch, "Normal")   
            EndSelect
            
          Case #Gadget_Search_ExitSearch
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Search_ExitSearch, "Hovered")                      : StatusBarButtonTip(#Window_Data, "ExitSearch")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Search_ExitSearch, "Pressed")                      : CloseMyWindow(#Window_Search)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Search_ExitSearch, "Normal")   
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; OwnerList controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_OwnerList_Owners
            Select EventType()
              Case #PB_EventType_LeftDoubleClick                                                                                          : EditOwner()
              Case #PB_EventType_RightDoubleClick                                                                                         : AddOwner()
            EndSelect
            
          Case #Gadget_OwnerList_SaveOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_SaveOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "SaveOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_SaveOwnerlist, "Pressed")                : ; SaveOwnerlist()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_SaveOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_AddOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_AddOwnerlist, "Hovered")                 : StatusBarButtonTip(#Window_OwnerList, "AddOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_AddOwnerlist, "Pressed")                 : AddOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_AddOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_DeleteOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_DeleteOwnerlist, "Hovered")              : StatusBarButtonTip(#Window_OwnerList, "DeleteOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_DeleteOwnerlist, "Pressed")              : DeleteOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_DeleteOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_EditOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_EditOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "EditOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_EditOwnerlist, "Pressed")                : EditOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_EditOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_HelpOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_HelpOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "HelpOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_HelpOwnerlist, "Pressed")                : ShowHelp("OwnerListForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_HelpOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_ExitOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_ExitOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "ExitOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_ExitOwnerlist, "Pressed")                : CloseMyWindow(#Window_OwnerList)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_ExitOwnerlist, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Owner editor controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Owner_OwnerName                : MixedStringCase(#Gadget_Owner_OwnerName)
            
          Case #Gadget_Owner_SaveOwner
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Owner_SaveOwner, "Hovered")                        : StatusBarButtonTip(#Window_OwnerList, "SaveOwner")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Owner_SaveOwner, "Pressed")                        : SaveOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Owner_SaveOwner, "Normal")
            EndSelect
          Case #Gadget_Owner_HelpOwner
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Owner_HelpOwner, "Hovered")                        : StatusBarButtonTip(#Window_OwnerList, "HelpOwner")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Owner_HelpOwner, "Pressed")                        : ShowHelp("OwnerForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Owner_HelpOwner, "Normal")
            EndSelect
          Case #Gadget_Owner_ExitOwner
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Owner_ExitOwner, "Hovered")                        : StatusBarButtonTip(#Window_OwnerList, "ExitOwner")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Owner_ExitOwner, "Pressed")                        : CloseMyWindow(#Window_Owner)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Owner_ExitOwner, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Help form controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Help_LoadHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_LoadHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "LoadHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_LoadHelp, "Pressed")                          : LoadHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_LoadHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_SaveHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_SaveHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "SaveHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_SaveHelp, "Pressed")                          : SaveHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_SaveHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_SearchHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_SearchHelp, "Hovered")                        : StatusBarButtonTip(#Window_Help, "SearchHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_SearchHelp, "Pressed")                        : SearchHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_SearchHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_PrintHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_PrintHelp, "Hovered")                         : StatusBarButtonTip(#Window_Help, "PrintHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_PrintHelp, "Pressed")                         : PrintHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_PrintHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_EditHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_EditHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "EditHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_EditHelp, "Pressed")                          : EditHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_EditHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_ExitHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_ExitHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "ExitHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_ExitHelp, "Pressed")                          : CloseMyWindow(#Window_Help)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_ExitHelp, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Print_PrintNow
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintNow, "Hovered")                         : StatusBarButtonTip(#Window_print, "NowPrint")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Print_PrintNow, "Pressed")                         : ForceHtmPrint()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintNow, "Normal")
            EndSelect
            
          Case #Gadget_Print_PrintPreview
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintPreview, "Hovered")                     : StatusBarButtonTip(#Window_print, "NowPreview")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Print_PrintPreview, "Pressed")                     : ForceHtmPreview()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintPreview, "Normal")
            EndSelect
            
          Case #Gadget_Print_PrintExit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintExit, "Hovered")                        : StatusBarButtonTip(#Window_print, "ExitPrint")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Print_PrintExit, "Pressed")                        : CloseMyWindow(#Window_Print)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintExit, "Normal")
            EndSelect

            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; Unhide the program window when the user clicks the icon in the tray
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_SysTray                                                                                                              : ShowProgramWindow()
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Until Program\QuitValue.i
  
  ;------------------------------------------------------------------------------------------------
  ; Save the program startup preferences
  ;------------------------------------------------------------------------------------------------
  
  UpdateString.s                                                        + 
  "UPDATE Preferences SET "                                             + 
  "SearchLimit = '"         +          Program\SearchLimit      + "', " + 
  "LastSearch = '"          + RepQuote(Program\LastSearch)      + "' "  + 
  "WHERE Record = 1"
  
  If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) = #DatabaseUpdateFail
    MessageRequester("Options Save Error", "Could not save the updated options into the database. " + DatabaseError(), #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Force the error log to be flushed to disk
  ;------------------------------------------------------------------------------------------------
  
  WriteErrorLog(ModuleName.s, MessageContent.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CloseWindow(#Window_Keeper)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndIf

;--------------------------------------------------------------------------------------------------
; 
;--------------------------------------------------------------------------------------------------

End

;   #PB_Event_Menu            : a menu has been selected
;   #PB_Event_Gadget          : a gadget has been pushed
;   #PB_Event_SysTray         : an icon IN the systray zone was clicked
;   #PB_Event_Timer           : a timer has reached its timeout
;   #PB_Event_CloseWindow     : the window close gadget has been pushed
;   #PB_Event_Repaint         : the window content has been destroyed And must be repainted (useful For 2D graphics operations)
;   #PB_Event_SizeWindow      : the window has been resized
;   #PB_Event_MoveWindow      : the window has been moved
;   #PB_Event_MinimizeWindow  : the window has been minimized
;   #PB_Event_MaximizeWindow  : the window has been maximized
;   #PB_Event_RestoreWindow   : the window has been restored To normal size (either from a minimum Or maximum size)
;   #PB_Event_ActivateWindow  : the window has been activated (got the focus)
;   #PB_Event_DeactivateWindow: the window has been deactivated (lost the focus)
;   #PB_Event_WindowDrop      : a Drag & Drop operation was finished on a window
;   #PB_Event_GadgetDrop      : a Drag & Drop operation was finished on a gadget 
;   #PB_Event_RightClick      : a right mouse button click has occurred on the window. This can be useful To display a popup menu
;   #PB_Event_LeftClick       : a left mouse button click has occurred on the window
;   #PB_Event_LeftDoubleClick : a left mouse button double-click has occurred on the window

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 513
; FirstLine = 496
; EnableAsm
; EnableXP
; UseIcon = Images\_16x16\Keeper.ico
; UseMainFile = Keeper.pb
; CommandLine = /Register Derek Elias
; CompileSourceDirectory
; EnableCompileCount = 519
; EnableBuildCount = 0