﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Export the list of categories to disk
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ImportCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CategoryFileName.s = OpenFileRequester("Add categories", Program\TemporaryDirectory  + #Basename + "_Categories.txt", "Text (*.txt)|*.txt;*.asc", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CategoryFileName.s <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CategoryFileId.i = ReadFile(#PB_Any, CategoryFileName.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CategoryFileId.i <> #NoFileHandle
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While Eof(CategoryFileId.i) = #NotEndOfFile
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        CurrentString.s = ReadString(CategoryFileId.i)
        
        iCategory.s     = ProperCaseString(StringField(CurrentString.s, 1, "|"))
        
        iItemCount.s    =                  StringField(CurrentString.s, 2, "|")
        
        iIconname.s     =                  StringField(CurrentString.s, 3, "|")
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If iCategory.s <> #Empty$ And Len(iCategory.s) > = 8
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          DatabaseUpdate.s          + 

          "INSERT INTO Categories(" + 
          
          "Category, "              + 

          "ItemCount, "             + 

          "Iconname) "              + 
          
          "VALUES('"                + 

          iCategory.s               +

          "', '"                    + 

          iItemCount                + 
          
          "', '"                    + 

          iIconname.s               + 
          
          "')"
          
          ;----------------------------------------------------------------------------------------
          ; Import into the database
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)  <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; Get the new record number if any
            ;--------------------------------------------------------------------------------------
            
            NewRecordNumber.s = DatabaseLastInsertRowId()
            
            ;--------------------------------------------------------------------------------------
            ; Proceed if we got a record number
            ;--------------------------------------------------------------------------------------
            
            If NewRecordNumber.s  <> #Empty$
              
              ;------------------------------------------------------------------------------------
              ; Display the new string of data
              ;------------------------------------------------------------------------------------
              
              AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, iCategory.s + #LF$ + NewRecordNumber.s, ImageID(#Image_ListNormal))
              
              If FileSize(Program\CategoryIcons  + Iconname.s) <> #NoPictureFound  And FileSize(Program\CategoryIcons  + Iconname.s) <> #FileIsDirectory
                
                UserIconHandle.i = LoadImage(#PB_Any, Program\CategoryIcons  + Iconname.s)
                
                If UserIconHandle.i <>  #NoPictureLoaded
                  
                  AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(iCategory.s) + #LF$  + KillQuote(iItemCount.s)  + #LF$  + KillQuote(iIconname.s) + #LF$  + Newrecordnumber.s, ImageID(UserIconHandle.i))
                  
                Else
                  
                  AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(iCategory.s) + #LF$  + #Empty$  + #LF$  + KillQuote(iIconname.s) + #LF$  + Newrecordnumber.s, ImageID(#Image_ListCategory))
                  
                  SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                  
                EndIf
                
              Else
                
                AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(iCategory.s) + #LF$  + #Empty$  + #LF$  + KillQuote(iIconname.s) + #LF$  + Newrecordnumber.s, ImageID(#Image_ListCategory))
                
                SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              UpdateCategoryItemCount(iCategory.s)
              
              ;------------------------------------------------------------------------------------
              ; Sort the strings
              ;------------------------------------------------------------------------------------
              
              SortCategoryEntries()
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              CurrentString.s    = #Empty$
              
              iCategory.s        = #Empty$
              
              iItemCount.s        = #Empty$
              
              iIconname.s        = #Empty$
        
              DatabaseUpdate.s   = #Empty$
              
              NewRecordNumber.s  = #Empty$
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Database failed to be updated so we didn't get a new record number.", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The category string is either empty or shorter than 5 characters.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Wend
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseFile(CategoryFileId.i)      
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "No category file handle was created.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "Nothing to open, user cancelled.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 46
; FirstLine = 24
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode