﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Load all the categories into the category bar
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure LoadCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s               + 

  "SELECT * FROM Categories " + 
  
  "ORDER BY Category ASC"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  LockWindowUpdate_(GadgetID(#Gadget_Keeper_Category))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "All items",      ImageID(#Image_ListAll))
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "Empty titles",   ImageID(#Image_ListEmpty))
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "Archived",       ImageID(#Image_ListArchived))
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "Favourites",     ImageID(#Image_ListFavourite))
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "Locked items",   ImageID(#Image_ListLocked))
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "Deleted items",  ImageID(#Image_ListDeleted))
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "No category",    ImageID(#Image_ListNocategory))
    
    AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, "No owner",       ImageID(#Image_ListNoowner))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    For ColourSet.i = 0 To 7
      
      SetGadgetItemColor(#Gadget_Keeper_Category, ColourSet.i, #PB_Gadget_FrontColor, $B30059, -1)
      
    Next ColourSet.i
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      passCategory.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0)) ; 
      
      passItemCount.s = KillQuote(GetDatabaseString(Program\DatabaseHandle,   1)) ;
      
      passIconname.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle,   2)) ;
      
      passRecord.s    =           GetDatabaseString(Program\DatabaseHandle,   3)  ;
      
      If FileSize(Program\CategoryIcons  + passIconname.s) <> #NoPictureFound  And FileSize(Program\CategoryIcons  + passIconname.s) <> #FileIsDirectory
        
        UserIconHandle.i = LoadImage(#PB_Any, Program\CategoryIcons  + passIconname.s)
        
        If UserIconHandle.i <>  #NoPictureLoaded
          
          AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(passCategory.s + " ("  + passItemCount.s + ")") + #LF$ + passItemCount.s + #LF$ + KillQuote(passIconname.s) + #LF$ + passRecord.s, ImageID(UserIconHandle.i))
          
        Else
          
          AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(passCategory.s + " ("  + passItemCount.s + ")") + #LF$ + passItemCount.s + #LF$ + KillQuote(passIconname.s) + #LF$ + passRecord.s, ImageID(#Image_ListCategory))
          
          SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
          
        EndIf
        
      Else
        
        AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(passCategory.s + " ("  + passItemCount.s + ")") + #LF$  + passItemCount.s  + #LF$  + KillQuote(passIconname.s) + #LF$  + passRecord.s, ImageID(#Image_ListCategory))
        
        SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
        
      EndIf
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CountGadgetItems(#Gadget_Keeper_Category) <> #NoItems
      
      SetGadgetState(#Gadget_Keeper_Category, #FirstItem)
      
      ShowCategory()
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "Could not retrieve categories from the database. " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  LockWindowUpdate_(0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 139
; FirstLine = 95
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0