﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Save the changed category data to the database
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SaveCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CategoryString.s  = RepQuote(GetGadgetText(#Gadget_Category_Category))
  
  Iconname.s        = RepQuote(GetGadgetText(#Gadget_Category_Categoryicon))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CategoryString.s <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Len(CategoryString.s) > = 6
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select Program\LastWindow
  
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Case  "Add A New Category"
          
          ;----------------------------------------------------------------------------------------
          ; Uppercase the first letter of the word
          ;----------------------------------------------------------------------------------------
          
          CategoryString.s = UCase(Left(CategoryString.s, 1)) + Mid(CategoryString.s, 2, Len(CategoryString.s) - 1)
          
          ItemCount.s       = "0"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          NewCategoryInsert.s       + 

          "INSERT INTO Categories(" + 
          
          "Category, "              + 
          
          "ItemCount, "             + 
          
          "Iconname) "              + 
          
          "VALUES("                 + 
          
          "'"                       + 

          CategoryString.s          + 

          "', '"                    + 

          ItemCount.s               + 

          "', '"                    + 

          Iconname.s                + 

          "')"

          ;----------------------------------------------------------------------------------------
          ; Now update the database with the new record
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, NewCategoryInsert.s)  <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; Get the new record number if any
            ;--------------------------------------------------------------------------------------
            
            NewRecordNumber.s = DatabaseLastInsertRowId()
            
            ;--------------------------------------------------------------------------------------
            ; Proceed if we got a record number
            ;--------------------------------------------------------------------------------------
            
            If NewRecordNumber.s  <> #Empty$
              
              If Toggle\MessageSave = #True
                
                MessageRequester("New Category", "New category: " + KillQuote(CategoryString.s)  + " has been saved to the database", #PB_MessageRequester_Ok)
              
              EndIf
            
              ;------------------------------------------------------------------------------------
              ; Display the new string of data
              ;------------------------------------------------------------------------------------
              
              If FileSize(Program\CategoryIcons  + Iconname.s) <> #NoPictureFound  And FileSize(Program\CategoryIcons  + Iconname.s) <> #FileIsDirectory
                
                UserIconHandle.i = LoadImage(#PB_Any, Program\CategoryIcons  + Iconname.s)
                
                If UserIconHandle.i <>  #NoPictureLoaded
                  
                  AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(CategoryString.s) + #LF$  + KillQuote(ItemCount.s)  + #LF$  + KillQuote(Iconname.s) + #LF$  + Newrecordnumber.s, ImageID(UserIconHandle.i))
                  
                Else
                  
                  AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(CategoryString.s) + #LF$  + #Empty$  + #LF$  + KillQuote(Iconname.s) + #LF$  + Newrecordnumber.s, ImageID(#Image_ListCategory))
                  
                  SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                  
                EndIf
                
              Else
                
                AddGadgetItem(#Gadget_Keeper_Category, #AtTheEndOfTheList, KillQuote(CategoryString.s) + #LF$  + #Empty$  + #LF$  + KillQuote(Iconname.s) + #LF$  + Newrecordnumber.s, ImageID(#Image_ListCategory))
                
                SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
                
              EndIf
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Database failed to be updated so we didn't get a new record number." + DatabaseError(), #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case  "Edit An Old Category"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CategoryUpdateString.s   + 

          "UPDATE Categories "     + 
          
          "SET Category = '"       + 

          CategoryString.s         + 

          "', "                    + 
           
          "Iconname = '"           + 

          Iconname.s               + 

          "' "                     + 
          
          "WHERE Record = '"       + 

          Category\Currentrecord.s + 

          "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, CategoryUpdateString.s)  <> #DatabaseUpdateFail
            
            If Toggle\MessageSave = #True
              
              MessageRequester("Old Category", "Old category: " + KillQuote(CategoryString.s)  + " has been saved to the database", #PB_MessageRequester_Ok)
            
            EndIf
              
            ;--------------------------------------------------------------------------------------
            ; Display the new or edited string of data
            ;--------------------------------------------------------------------------------------
            
            SetInfoBarArea("Headings",  "Info", "The edited category was saved to Categories.", #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; Create the main table category update
            ;--------------------------------------------------------------------------------------
            
            KeeperUpdateString.s        + 

            "UPDATE Keeper "            + 
            
            "SET Category = '"          + 

            CategoryString.s            + 

            "' "                        + 
            
            "WHERE Category = '"        + 

            Category\OldCategoryString  + 

            "'"
            
            ;--------------------------------------------------------------------------------------
            ; Update main table when category string has changed
            ;--------------------------------------------------------------------------------------
            
            If DatabaseUpdate(Program\DatabaseHandle, KeeperUpdateString.s)
              
              SetGadgetItemText(#Gadget_Keeper_Category, Category\CurrentLine, KillQuote(CategoryString.s), #CategoryTitleColumn)
              
              If FileSize(Program\CategoryIcons  + Iconname.s) <> #NoPictureFound  And FileSize(Program\CategoryIcons  + Iconname.s) <> #FileIsDirectory
                
                UserIconHandle.i = LoadImage(#PB_Any, Program\CategoryIcons  + Iconname.s)
                
                If UserIconHandle.i <>  #NoPictureLoaded
                  
                  SetGadgetItemImage(#Gadget_Keeper_Category, Category\CurrentLine.i, ImageID(UserIconHandle.i))
                  
                Else
                  
                  SetGadgetItemImage(#Gadget_Keeper_Category, Category\CurrentLine.i, ImageID(#Image_ListCategory))
                  
                  SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                  
                EndIf
                
              Else
                
                SetGadgetItemImage(#Gadget_Keeper_Category, Category\CurrentLine.i, ImageID(#Image_ListCategory))
                
                SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
                
              EndIf
              
              SetInfoBarArea("Headings", "Info", "Categories updated in main database with new category name.", #PB_Compiler_Procedure)
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Could not update categories in main database with new category." + DatabaseError(), #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Tell the user about the new update
            ;--------------------------------------------------------------------------------------
            
            SetInfoBarArea("Headings", "Info", "Old record: " + Category\CurrentRecord + ", " + KillQuote(CategoryString.s) + " has been saved to the database.", #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else

            SetInfoBarArea("Headings", "Error", "The database update failed or was empty. " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseMyWindow(#Window_Category)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
  
      UpdateCategoryItemCount(CategoryString.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SortCategoryEntries()
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Warn", "The new category is too short. 6 characters is really not useful.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "The category string was empty, there is nothing to save.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 189
; FirstLine = 151
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0