﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure CloseMyWindow(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the current line number
  ;------------------------------------------------------------------------------------------------
  
  FocusLine.i = Program\CurrentLine
  
  ;------------------------------------------------------------------------------------------------
  ; Remove hover events for windows
  ;------------------------------------------------------------------------------------------------
  
  Select Window.i
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_Category
      
      RemoveHoverGadget(GadgetID(#Gadget_Category_SaveCategory))
      
      RemoveHoverGadget(GadgetID(#Gadget_Category_HelpCategory))
      
      RemoveHoverGadget(GadgetID(#Gadget_Category_ExitCategory))
      
      ;--------------------------------------------------------------------------------------------
      ; Data addition and editing (A main window)
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_Data
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_SaveData))
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_ExportData))
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_ImportData))
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_HelpData))
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_ExitData))
      
      ;--------------------------------------------------------------------------------------------
      ; Advanced record search (A main window)
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_Search
      
      RemoveHoverGadget(GadgetID(#Gadget_Search_RunSearch))

      RemoveHoverGadget(GadgetID(#Gadget_Search_ExitSearch))
      
      RemoveHoverGadget(GadgetID(#Gadget_Search_ExitSearch))
      
      ;--------------------------------------------------------------------------------------------
      ; Owner list management (A main window)
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_OwnerList
      
      RemoveHoverGadget(GadgetID(#Gadget_OwnerList_SaveOwnerlist))
      
      RemoveHoverGadget(GadgetID(#Gadget_OwnerList_AddOwnerlist))
      
      RemoveHoverGadget(GadgetID(#Gadget_OwnerList_DeleteOwnerlist))
      
      RemoveHoverGadget(GadgetID(#Gadget_OwnerList_EditOwnerlist))
      
      RemoveHoverGadget(GadgetID(#Gadget_OwnerList_HelpOwnerlist))
      
      RemoveHoverGadget(GadgetID(#Gadget_OwnerList_ExitOwnerlist))
      
      ;--------------------------------------------------------------------------------------------
      ; Owner data manager (A child of Ownerlist window)
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Owner
      
      RemoveHoverGadget(GadgetID(#Gadget_Owner_SaveOwner))
      
      RemoveHoverGadget(GadgetID(#Gadget_Owner_HelpOwner))
      
      RemoveHoverGadget(GadgetID(#Gadget_Owner_ExitOwner))
      
      DisableWindow(#Window_OwnerList, #False)    ; Re-enable input on parent window
      
      HideWindow(#Window_OwnerList, #False)       ; Show the parent window again
      
      ProcedureReturn
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Help
      
      RemoveHoverGadget(GadgetID(#Gadget_Help_LoadHelp))
      
      RemoveHoverGadget(GadgetID(#Gadget_Help_SaveHelp))
      
      RemoveHoverGadget(GadgetID(#Gadget_Help_SearchHelp))
      
      RemoveHoverGadget(GadgetID(#Gadget_Help_PrintHelp))
      
      RemoveHoverGadget(GadgetID(#Gadget_Help_EditHelp))
      
      RemoveHoverGadget(GadgetID(#Gadget_Help_ExitHelp))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_Print
      
      RemoveHoverGadget(GadgetID(#Gadget_Print_PrintNow))
      
      RemoveHoverGadget(GadgetID(#Gadget_Print_PrintPreview))
      
      RemoveHoverGadget(GadgetID(#Gadget_Print_PrintExit))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Shortcuts
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Errorlog
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Close the form window if it is not the master window
  ;------------------------------------------------------------------------------------------------
  
  CloseWindow(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Tell the user what just happened
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings",  "Info", "Window (" + Program\LastWindow + ") closed.", "CloseMyWindow")
  
  ;------------------------------------------------------------------------------------------------
  ; Zero certain variables not from the main window when they are closed
  ;------------------------------------------------------------------------------------------------
  
  ;------------------------------------------------------------------------------------------------
  ; Refocus on main window and current record when data window is closed
  ;------------------------------------------------------------------------------------------------
  
  If Window.i <> #Window_Keeper
    
    Program\WindowMutex     = #False                                                                ; Make sure other windows can open now  
    
    Program\CurrentLine     = #NoCurrentLine                                                        ; Make sure no line can be selected accidentally
    
    Program\CurrentRecord   = #Empty$                                                               ; Nullify the current record number to avoid mistakes
    
    Program\LastWindow      = #Empty$                                                               ; Clear last used windows state
    
    DisableWindow(#Window_Keeper, #False)
    
    HideWindow(#Window_Keeper, #False)
    
    SetActiveWindow(#Window_Keeper)
    
    SetActiveGadget(#Gadget_Keeper_Titles)
    
    If FocusLine.i <> 0
      
      SetGadgetState(#Gadget_Keeper_Titles, FocusLine.i)
      
    Else
      
      FocusLine.i = CountGadgetItems(#Gadget_Keeper_Titles) - 1
      
    EndIf
   
    PostEvent(#PB_Event_Gadget, #Window_Keeper, #Gadget_Keeper_Titles, #PB_EventType_Change)

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 136
; FirstLine = 102
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0