﻿;==============================================================================================================================================================================
; Image menu creation procedure
;==============================================================================================================================================================================

Procedure CreateMainMenu()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CreateImageMenu(#MenuBar_Keeper, WindowID(#Window_Keeper))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  MenuTitle("Files")
  
  MenuItem(#MenuBar_Keeper_ImportEntries,     #Text_ImportEntries     + #TAB$ + GetShortcutText(#ShortcutKeys_ImportEntries),     ImageID(#MenuBarIcon_Keeper_ImportEntries))
  
  MenuItem(#MenuBar_Keeper_VacuumDatabase,    #Text_VacuumDatabase    + #TAB$ + GetShortcutText(#ShortcutKeys_VacuumDatabase),    ImageID(#MenuBarIcon_Keeper_VacuumDatabase))
  
  MenuBar()
  
  MenuItem(#MenuBar_Keeper_ExitProgram,       #Text_ExitProgram       + #TAB$ + GetShortcutText(#ShortcutKeys_ExitProgram),       ImageID(#MenuBarIcon_Keeper_ExitProgram))
  
  MenuTitle("Categories")
  
  MenuItem(#MenuBar_Keeper_AddCategory,       #Text_AddCategory       + #TAB$ + GetShortcutText(#ShortcutKeys_AddCategory),       ImageID(#MenuBarIcon_Keeper_AddCategory))
  
  MenuItem(#MenuBar_Keeper_CopyCategory,      #Text_CopyCategory      + #TAB$ + GetShortcutText(#ShortcutKeys_CopyCategory),      ImageID(#MenuBarIcon_Keeper_CopyCategory))
  
  MenuItem(#MenuBar_Keeper_DeleteCategory,    #Text_DeleteCategory    + #TAB$ + GetShortcutText(#ShortcutKeys_DeleteCategory),    ImageID(#MenuBarIcon_Keeper_DeleteCategory))
  
  MenuItem(#MenuBar_Keeper_EditCategory,      #Text_EditCategory      + #TAB$ + GetShortcutText(#ShortcutKeys_EditCategory),      ImageID(#MenuBarIcon_Keeper_EditCategory))
  
  MenuBar()
  
  MenuItem(#MenuBar_Keeper_ExportCategories,  #Text_ExportCategories  + #TAB$ + GetShortcutText(#ShortcutKeys_ExportCategories),  ImageID(#MenuBarIcon_Keeper_ExportCategories))
  
  MenuItem(#MenuBar_Keeper_ImportCategories,  #Text_ImportCategories  + #TAB$ + GetShortcutText(#ShortcutKeys_ImportCategories),  ImageID(#MenuBarIcon_Keeper_ImportCategories))
  
  MenuTitle("Data")
  
  MenuItem(#MenuBar_Keeper_AddItem,           #Text_AddItem           + #TAB$ + GetShortcutText(#ShortcutKeys_AddItem),           ImageID(#MenuBarIcon_Keeper_AddItem))
  
  MenuItem(#MenuBar_Keeper_CopyItem,          #Text_CopyItem          + #TAB$ + GetShortcutText(#ShortcutKeys_CopyItem),          ImageID(#MenuBarIcon_Keeper_CopyItem))
  
  MenuItem(#MenuBar_Keeper_DeleteItem,        #Text_DeleteItem        + #TAB$ + GetShortcutText(#ShortcutKeys_DeleteItem),        ImageID(#MenuBarIcon_Keeper_DeleteItem))
  
  MenuItem(#MenuBar_Keeper_EditItem,          #Text_EditItem          + #TAB$ + GetShortcutText(#ShortcutKeys_EditItem),          ImageID(#MenuBarIcon_Keeper_EditItem))
  
  MenuItem(#MenuBar_Keeper_FavouriteItem,     #Text_FavouriteItem     + #TAB$ + GetShortcutText(#ShortcutKeys_FavouriteItem),     ImageID(#MenuBarIcon_Keeper_FavouriteItem))
  
  MenuItem(#MenuBar_Keeper_LockItem,          #Text_LockItem          + #TAB$ + GetShortcutText(#ShortcutKeys_LockItem),          ImageID(#MenuBarIcon_Keeper_LockItem))
  
  MenuItem(#MenuBar_Keeper_PrintItem,         #Text_PrintItem         + #TAB$ + GetShortcutText(#ShortcutKeys_PrintItem),         ImageID(#MenuBarIcon_Keeper_PrintItem))
  
  MenuBar()
  
  MenuItem(#MenuBar_Keeper_ExportItem,        #Text_Exportitem        + #TAB$ + GetShortcutText(#ShortcutKeys_ExportItem),        ImageID(#MenuBarIcon_Keeper_ExportItem))
  
  MenuItem(#MenuBar_Keeper_AttachItem,        #Text_AttachItem        + #TAB$ + GetShortcutText(#ShortcutKeys_AttachItem),        ImageID(#MenuBarIcon_Keeper_AttachItem))
  
  MenuTitle("Utilities")
  
  MenuItem(#MenuBar_Keeper_FindInformation,   #Text_FindInformation   + #TAB$ + GetShortcutText(#ShortcutKeys_FindInformation),   ImageID(#MenuBarIcon_Keeper_FindInformation))
  
  MenuItem(#MenuBar_Keeper_AdvancedSearch,    #Text_AdvancedSearch    + #TAB$ + GetShortcutText(#ShortcutKeys_AdvancedSearch),    ImageID(#MenuBarIcon_Keeper_AdvancedSearch))
  
  MenuBar()
  
  MenuItem(#MenuBar_Keeper_SelectAllItems,    #Text_SelectAllItems    + #TAB$ + GetShortcutText(#ShortcutKeys_SelectAllItems),    ImageID(#MenuBarIcon_Keeper_SelectAllItems))
  
  MenuTitle("Options")
  
  MenuItem(#MenuBar_Keeper_TitleClock,        #Text_Titleclock        + #TAB$ + GetShortcutText(#ShortcutKeys_Titleclock))
  
  MenuItem(#MenuBar_Keeper_ScreenSnap,        #Text_Screensnap        + #TAB$ + GetShortcutText(#ShortcutKeys_Screensnap))
  
  MenuItem(#MenuBar_Keeper_StickyWindow,      #Text_Stickywindow      + #TAB$ + GetShortcutText(#ShortcutKeys_Stickywindow))
  
  MenuItem(#MenuBar_Keeper_ShowToolbar,       #Text_ShowToolbar       + #TAB$ + GetShortcutText(#ShortcutKeys_ShowToolbar))
  
  MenuItem(#MenuBar_Keeper_HideDetail,        #Text_HideDetail        + #TAB$ + GetShortcutText(#ShortcutKeys_HideDetail))
  
  MenuBar()
  
  MenuItem(#MenuBar_Keeper_EditPassword,      #Text_EditPassword      + #TAB$ + GetShortcutText(#ShortcutKeys_EditPassword),      ImageID(#MenuBarIcon_Keeper_EditPassword))
  
  MenuItem(#MenuBar_Keeper_LockProgram,       #Text_LockProgram       + #TAB$ + GetShortcutText(#ShortcutKeys_LockProgram),       ImageID(#MenuBarIcon_Keeper_LockProgram))
  
  MenuTitle("Help")
  
  MenuItem(#MenuBar_Keeper_AboutProgram,      #Text_AboutProgram      + #TAB$ + GetShortcutText(#ShortcutKeys_AboutProgram),      ImageID(#MenuBarIcon_Keeper_AboutProgram))
  
  MenuItem(#MenuBar_Keeper_KeyboardShortcuts, #Text_KeyboardShortcuts + #TAB$ + GetShortcutText(#ShortcutKeys_KeyboardShortcuts), ImageID(#MenuBarIcon_Keeper_KeyboardShortcuts))
  
  MenuItem(#MenuBar_Keeper_ProgramHelp,       #Text_ProgramHelp       + #TAB$ + GetShortcutText(#ShortcutKeys_ProgramHelp),       ImageID(#MenuBarIcon_Keeper_ProgramHelp))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 10
; Folding = -
; EnableXP
; HideErrorLog