﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Set the correct icons to the selected hoverable gadget
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SetHoverIcons(Gadget.i, Image.i, State.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i x, y, w, h, Xmax, Ymax, Result
  
  Protected.l a, a_, max_x, max_y, ext
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If IsGadget(Gadget.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If IsImage(Image.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select State.s

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------

        Case "Hovered"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If IsImage(Image)
            
            ; Extend on all sides by Glow\GlowRadius pixels if Glow\ExtendCanvas is #True
            
            Glow\GlowColour   =  Random(GlowColours())
            
            If Glow\ExtendCanvas
              
              ext = Glow\GlowRadius
              
            EndIf
            
            ; Create output image
            
            Result = CreateImage(#PB_Any, ImageWidth(Image) + ext << 1, ImageHeight(Image) + ext << 1, 32, #PB_Image_Transparent)
            
            If Result
              
              StartDrawing(ImageOutput(Result))
              
              DrawingMode(#PB_2DDrawing_AllChannels)     
              
              DrawImage(ImageID(Image), ext, ext)
              
              max_x = OutputWidth() - 1
              
              max_y = OutputHeight() - 1
              
              ; Dim arrays
              
              Protected Dim AlphaChannel.a(max_y, max_x)
              
              Protected Dim AlphaChannelTmp.a(max_y, max_x)
              
              ; build alpha channel array
              
              For y = 0 To max_y
                
                For x = 0 To max_x
                  
                  AlphaChannel(y, x) = Point(x, y) >> 24
                  
                Next
                
              Next
              
              ; Blur alpha channel
              
              For y = 0 To max_y
                
                a_ = AlphaChannel(y, 0)
                
                For x = 1 To Glow\GlowRadius
                  
                  a_ + AlphaChannel(y, x)
                  
                Next
                
                x = 0
                
                While x <= max_x
                  
                  a = a_ >> 2
                  
                  If a > 255 : a = 255 : EndIf
                  
                  AlphaChannelTmp(y, x) = a
                  
                  If x >= Glow\GlowRadius
                    
                    a_ - AlphaChannel(y, x - Glow\GlowRadius)
                    
                  EndIf
                  
                  x + 1
                  
                  If x + Glow\GlowRadius <= max_x
                    
                    a_ + AlphaChannel(y, x + Glow\GlowRadius)
                    
                  EndIf
                  
                Wend
                
              Next
              
              For x = 0 To max_x
                
                a_ = AlphaChannelTmp(0, x)
                
                For y = 1 To Glow\GlowRadius
                  
                  a_ + AlphaChannelTmp(y, x)
                  
                Next
                
                y = 0
                
                While y <= max_y
                  
                  a = a_ >> 2
                  
                  If a > 255 : a = 255 : EndIf
                  
                  AlphaChannel(y, x) = a
                  
                  If y >= Glow\GlowRadius
                    
                    a_ - AlphaChannelTmp(y - Glow\GlowRadius, x)
                    
                  EndIf
                  
                  y + 1
                  
                  If y + Glow\GlowRadius <= max_y
                    
                    a_ + AlphaChannelTmp(y + Glow\GlowRadius, x)
                    
                  EndIf
                  
                Wend
                
              Next
             
              ; Create blurred glow image
              
              Glow\GlowColour & $ffffff
              
              For y = 0 To max_y
                
                For x = 0 To max_x
                  
                  Plot(x, y, Glow\GlowColour | AlphaChannel(y, x) << 24)
                  
                Next
                
              Next
              
              ; Merge with original
              
              DrawingMode(#PB_2DDrawing_AlphaBlend)
              
              DrawImage(ImageID(Image), ext, ext)
              
              StopDrawing()
              
            EndIf
            
          EndIf
          
          SetGadgetState(Gadget.i, ImageID(Result))
          
          FreeImage(Result)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Pressed"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If IsImage(Image.i)
            
            TempImage.i = CopyImage(Image.i, #PB_Any)
            
            If TempImage.i
              
              StartDrawing(ImageOutput(TempImage.i))
              
              Xmax = OutputWidth()  - 1
              
              Ymax = OutputHeight() - 1
              
              For y = 0 To Ymax
                
                For x = 0 To Xmax
                  
                  Plot(x, y, Point(x, y) ! $FFFFFF)
                  
                Next x
                
              Next y
              
              StopDrawing()
              
              SetGadgetState(Gadget.i, ImageID(TempImage.i))
              
              FreeImage(TempImage.i)
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Normal"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetState(Gadget.i, ImageID(Image.i))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "The image for the gadget hovered over or pressed seems to be missing!!", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "This is not an initialised hoverable gadget", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 216
; FirstLine = 205
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0