﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Attach a document or file to the current record
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure AttachItemToData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Keeper_Titles)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NoCurrentLine

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CurrentRecord.s = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #RecordColumn)

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CurrentRecord.s <> #NoRecordNumber

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CurrentTitleString.s  = Trim(StringField(GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #TitleColumn), 1, "("))
      
      AttachmentCount.s     = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #AttachmentsColumn)

      AttachmentNames.s     = OpenFileRequester("Attach to (" + CurrentTitleString.s  + ")", "", "Text (*.txt)|*.txt;*.asc|Pdf (*.pdf)|*.pdf|All files (*.*)|*.*", 1, #PB_Requester_MultiSelection)

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While AttachmentNames.s

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If AttachmentNames.s  <> #Empty$

          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CurrentAttachmentHandle.i = ReadFile(#PB_Any, AttachmentNames.s)

          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If CurrentAttachmentHandle.i

            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            AttachmentFileLength.i  = Lof(CurrentAttachmentHandle.i)

            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            *InputBuffer            = AllocateMemory(AttachmentFileLength.i)

            *BlobBuffer             = AllocateMemory(FileInSize.i)

            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If *InputBuffer And *BlobBuffer

              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If ReadData(CurrentAttachmentHandle.i, *InputBuffer, FileInSize.i) = FileInSize.i

                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                CompressedLength.i = CompressMemory(*InputBuffer, AttachmentFileLength.i, *BlobBuffer, AttachmentFileLength.i)

                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If CompressedLength.i

                  SetDatabaseBlob(Program\DatabaseHandle, 0, *BlobBuffer,   FileInSize.i)

                Else

                  SetDatabaseBlob(Program\DatabaseHandle, 0, *InputBuffer,  FileInSize.i)

                EndIf

                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                DatabaseUpdate.s = "INSERT INTO Attachments (Attachment, Filename, Record) "

                DatabaseUpdate.s + "VALUES (?, '"  + RepQuote(GetFilePart(AttachmentNames.s)) + "', '" + CurrentRecord.s + "')"

                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail

                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  NewRecord.s = DatabaseLastInsertRowId()

                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  If NewRecord.s <> #Empty$

                    AttachmentsSaved.i = #True

                    SetInfoBarArea("Headings", "Info", AttachmentNames.s  + " saved for record: " + CurrentRecord.s, #PB_Compiler_Procedure)

                  Else
                    
                    SetInfoBarArea("Headings", "Error", "Could not gtet a new record number for the attachment inserted. "  + DatabaseError(), #PB_Compiler_Procedure)  
                    
                  EndIf

                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "The database insertion of the specified attachment has failed "  + DatabaseError(), #PB_Compiler_Procedure)  
                  
                EndIf

                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings", "Error", "Could not read the data from the specified attachment file.", #PB_Compiler_Procedure)  
                
              EndIf

              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FreeMemory(*BlobBuffer)

              FreeMemory(*InputBuffer)

              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Could not allocate memory areas to save the specified attachment file.", #PB_Compiler_Procedure)  
              
            EndIf

            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            CloseFile(CurrentAttachmentHandle.i)

            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Warn", "Could not open the specified attachment file.", #PB_Compiler_Procedure)  
            
          EndIf

          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Info", "Nothing to do, user cancelled the attachment process", #PB_Compiler_Procedure)
          
        EndIf

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        AttachmentNames.s = NextSelectedFileName() 

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Wend 

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If AttachmentsSaved.i = #True
        
        UpdateTitleAttachmentCount(CurrentLine.i, CurrentRecord.s)
        
        AttachmentsSaved.i = #False
        
      EndIf

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "There is no record number on the current line", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no current line to get a record number from", #PB_Compiler_Procedure)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 247
; FirstLine = 219
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode