﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Mark the selected item as deleted
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure DeleteCurrentData()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Keeper_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentCategory.s = GetGadgetText(#Gadget_Keeper_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current deleted state
    ;----------------------------------------------------------------------------------------------
    
    passArchived.s        = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #ArchivedColumn)
    
    passFavourite.s       = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #FavouriteColumn)
    
    passArchived.s        = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #ArchivedColumn)
    
    passLocked.s          = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #LockedColumn)
    
    passDeleted.s         = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #DeletedColumn)
    
    passRecord.s          = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If passLocked.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If passArchived.s <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If  passDeleted.s = "0"
          
          passDeleted.s = "1"
          
        ElseIf  passDeleted.s = "1"
          
          passDeleted.s = "0"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; Proceed if we got a record number
        ;------------------------------------------------------------------------------------------
        
        If passRecord.s <> #Empty$
          
          ;----------------------------------------------------------------------------------------
          ; Try to delete the selected record from the database
          ;----------------------------------------------------------------------------------------
          
          QueryString.s = "UPDATE Keeper "
          
          QueryString.s + "SET Deleted = '"   + passDeleted.s + "' "
          
          QueryString.s + "WHERE Record = '"  + passRecord.s  + "'"
          
          ;----------------------------------------------------------------------------------------
          ; Try to delete the selected record from the database
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)  <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If passLocked.s = "1"
              
              SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListLocked))
              
            ElseIf  passLocked.s <> "1"
              
              If passDeleted.s = "1"
                
                If CurrentCategory.s <> "Deleted items"
                  
                  SetGadgetItemData(#Gadget_Keeper_Titles,  CurrentLine.i, Val(passDeleted.s))
                  
                  RedrawWindow_(GadgetID(#Gadget_Keeper_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
                  
                  SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListDeleted))
                  
                EndIf
                
              ElseIf passDeleted.s <> "1"
                
                If passFavourite.s = "1"
                  
                  SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListFavourite))
                  
                ElseIf passFavourite.s <> "1"
                  
                  SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListNormal))
                  
                EndIf
                
              EndIf
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetGadgetItemText(#Gadget_Keeper_Titles,  CurrentLine.i, passDeleted.s, #DeletedColumn)
            
            ;--------------------------------------------------------------------------------------
            ; Remove deleetd item from normal view or remove undeleted item from deleted view
            ;--------------------------------------------------------------------------------------
            
            If CurrentCategory.s <> "Deleted items" And passDeleted.s = "1"
              
              RemoveGadgetItem(#Gadget_Keeper_Titles, CurrentLine.i)
              
            ElseIf  CurrentCategory.s = "Deleted items" And passDeleted.s = "0"
              
              RemoveGadgetItem(#Gadget_Keeper_Titles, CurrentLine.i)
  
            EndIf
            
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "No record number found for line " + Str(CurrentLine.i), #PB_Compiler_Procedure)
          
        EndIf
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
      
      Else
        
        SetInfoBarArea("Headings", "Info", "Cannot delete this record, it is currently Archived.", #PB_Compiler_Procedure)
        
      EndIf
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    Else
      
      SetInfoBarArea("Headings", "Info", "Cannot delete this record, it is currently locked.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "There is no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 205
; FirstLine = 149
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0