﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Handle all list display jobs from add, edit, list, import modes etc
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure DisplayTitleString(LineNumber.i, DisplayMode.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select DisplayMode.s

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case  "AddMode"
    
      ;--------------------------------------------------------------------------------------------
      ; Add Keeper items to the list
      ;--------------------------------------------------------------------------------------------
      
      TitleString.s       = Keeper\Title         +  " (" +   Keeper\Attachments  + ")"  + #LF$
      
     ;InformationString.s = Keeper\Information                                          + #LF$
      
      CategoryString.s    = Keeper\Category                                             + #LF$
      
      ArchivedString.s    = Keeper\Archived                                             + #LF$
      
      FavouriteString.s   = Keeper\Favourite                                            + #LF$

      LockedString.s      = Keeper\Locked                                               + #LF$
      
      DeletedString.s     = Keeper\Deleted                                              + #LF$
      
      UpdatedString.s     = Keeper\Updated                                              + #LF$
      
      OwnerString.s       = Keeper\Owner                                                + #LF$
      
      AttachmentString.s  = Keeper\Attachments                                          + #LF$
      
      RecordString.s      = Keeper\Record

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ListString.s        = TitleString.s     + CategoryString.s    + ArchivedString.s
      
      ListString.s        + FavouriteString.s + LockedString.s      + DeletedString.s

      ListString.s        + UpdatedString.s   + OwnerString.s       + AttachmentString.s
      
      ListString.s        + RecordString.s

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keeper_Titles, #AtTheEndOfTheList,  KillQuote(ListString.s))
      
      ;--------------------------------------------------------------------------------------------
      ; Set a single colum to a different colour
      ;--------------------------------------------------------------------------------------------

      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $0000FF, #TitleColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $00FF00, #CategoryColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $00FFFF, #ArchivedColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $00FFFF, #FavouriteColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $FF0000, #LockedColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $FF00FF, #DeletedColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $FFFF00, #UpdatedColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $FF0000, #OwnerColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $000080, #AttachmentsColumn)
      
      SetGadgetItemColor(#Gadget_Keeper_Titles, #PB_All, #PB_Gadget_FrontColor, $008000, #RecordColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ListString.s = #Empty$

      ;--------------------------------------------------------------------------------------------
      ; Update columns in the list for an edited record
      ;--------------------------------------------------------------------------------------------
      
    Case  "EditMode"
      
      ;--------------------------------------------------------------------------------------------
      ; Update the details in the list for the selected record
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i, KillQuote(Keeper\Title) +  " (" +   Keeper\Attachments  + ")", #TitleColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i, KillQuote(Keeper\Category),                                    #CategoryColumn)
      
     ;SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i, KillQuote(Keeper\Information),                                 #InformationColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Archived,                                     #ArchivedColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Favourite,                                    #FavouriteColumn)

      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Locked,                                       #LockedColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Deleted,                                      #DeletedColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Updated,                                      #UpdatedColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Owner,                                        #OwnerColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Attachments,                                  #AttachmentsColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, LineNumber.i,           Keeper\Record,                                       #RecordColumn)

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Keeper\Archived <> "1"
    
    If Keeper\Locked = "1"
      
      SetGadgetItemImage(#Gadget_Keeper_Titles, LineNumber.i, ImageID(#Image_ListLocked))
      
    ElseIf  Keeper\Locked <> "1"
      
      If Keeper\Deleted = "1"
        
        SetGadgetItemData(#Gadget_Keeper_Titles,  LineNumber.i, Val(Keeper\Deleted))
        
        RedrawWindow_(GadgetID(#Gadget_Keeper_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
        
        SetGadgetItemImage(#Gadget_Keeper_Titles, LineNumber.i, ImageID(#Image_ListDeleted))
        
      ElseIf Keeper\Deleted <> "1"
        
        If Keeper\Favourite = "1"
          
          SetGadgetItemImage(#Gadget_Keeper_Titles, LineNumber.i, ImageID(#Image_ListFavourite))
          
        ElseIf Keeper\Favourite <> "1"
          
          SetGadgetItemImage(#Gadget_Keeper_Titles, LineNumber.i, ImageID(#Image_ListNormal))
          
        EndIf
        
      EndIf
      
    EndIf
    
  Else
    
    SetGadgetItemImage(#Gadget_Keeper_Titles, LineNumber.i, ImageID(#Image_ListArchived))
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 132
; FirstLine = 121
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0