﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure EditOldData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine = GetGadgetState(#Gadget_Keeper_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\CurrentLine <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord = GetGadgetItemText(#Gadget_Keeper_Titles, Program\CurrentLine, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    passLocked.s  = GetGadgetItemText(#Gadget_Keeper_Titles, Program\CurrentLine, #LockedColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If passLocked.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      passDeleted.s = GetGadgetItemText(#Gadget_Keeper_Titles, Program\CurrentLine, #DeletedColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If passDeleted.s <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Program\CurrentRecord <> #Empty$
          
          ;----------------------------------------------------------------------------------------
          ; Check if a previous window is open
          ;----------------------------------------------------------------------------------------
          
          If Program\WindowMutex <> #True
            
            ;--------------------------------------------------------------------------------------
            ; Try to open the data window
            ;--------------------------------------------------------------------------------------
            
            If Window_Data()
              
              ;------------------------------------------------------------------------------------
              ; Prevent user input on the main window
              ;------------------------------------------------------------------------------------
              
              DisableWindow(#Window_Keeper, #True)
              
              ;------------------------------------------------------------------------------------
              ; Warn other components a window is open and not to attempt to open another
              ;------------------------------------------------------------------------------------
              
              Program\WindowMutex = #True
              
              ;------------------------------------------------------------------------------------
              ; Add the various keyboard shortcuts
              ;------------------------------------------------------------------------------------
              
              AddKeyboardShortcut(#Window_Data, #ShortcutValue_SaveData,         #KeyboardShortcut_SaveData)
              
              AddKeyboardShortcut(#Window_Data, #ShortcutValue_ExportData,       #KeyboardShortcut_ExportData)
              
              AddKeyboardShortcut(#Window_Data, #ShortcutValue_ImportData,       #KeyboardShortcut_ImportData)
              
              AddKeyboardShortcut(#Window_Data, #ShortcutValue_HelpData,         #KeyboardShortcut_HelpData)
              
              AddKeyboardShortcut(#Window_Data, #ShortcutValue_ExitData,         #KeyboardShortcut_ExitData)
              
              AddKeyboardShortcut(#Window_Data, #ShortcutValue_EscapeData,       #KeyboardShortcut_EscapeData)
              
              AddKeyboardShortcut(#Window_Data, #ShortcutValue_SearchData,       #KeyboardShortcut_SearchData)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              AddHoverGadget(GadgetID(#Gadget_Data_SaveData))
              
              AddHoverGadget(GadgetID(#Gadget_Data_ExportData))
              
              AddHoverGadget(GadgetID(#Gadget_Data_ImportData))
              
              AddHoverGadget(GadgetID(#Gadget_Data_HelpData))
              
              AddHoverGadget(GadgetID(#Gadget_Data_ExitData))
              
              ;------------------------------------------------------------------------------------
              ; Remove theme support from the comment box or it retains a border even when API removed
              ;------------------------------------------------------------------------------------
              
              RemoveBorders(#Gadget_Data_Details)
              
              ;------------------------------------------------------------------------------------
              ; Use the common message as a window identifier
              ;------------------------------------------------------------------------------------
              
              Program\LastWindow = "Edit Old Keeper Item"
              
              ;------------------------------------------------------------------------------------
              ; Set the window title with the common message and next record number
              ;------------------------------------------------------------------------------------
              
              SetWindowTitle(#Window_Data, Program\LastWindow + "   --   Record number: " + Program\CurrentRecord)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillComboBoxImage(#Gadget_Data_cCategory, "SELECT Category, Iconname FROM Categories ORDER BY Category", Program\CategoryIcons, #Image_ListNocategory)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillComboBoxImage(#Gadget_Data_Owner, "SELECT Owner, Iconname FROM Owners ORDER BY Owner", Program\OwnerIcons, #Image_ListNoowner)
              
              ;------------------------------------------------------------------------------------
              ; Set initial search cue font
              ;------------------------------------------------------------------------------------
              
              SetGadgetFont(#Gadget_Data_Finddata, FontID(Cue\SearchCueFont))
              
              ;------------------------------------------------------------------------------------
              ; Limit the number of search box characters and set the cue banner text. These variables are 
              ; set in the Keeper_Myconstants file.
              ;------------------------------------------------------------------------------------
              
              SendMessage_(GadgetID(#Gadget_Data_Finddata), #EM_SETLIMITTEXT, 67, 0)
              SendMessage_(GadgetID(#Gadget_Data_Finddata), #EM_SETCUEBANNER,  1,  Cue\SearchCueText)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              QueryString.s = "SELECT * FROM Keeper "
              
              QueryString.s + "WHERE Record = '"  + Program\CurrentRecord + "'"
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
                
                While NextDatabaseRow(Program\DatabaseHandle)
                  
                  Keeper\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))                 ;
                  
                  Keeper\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))                 ;
                  
                  Keeper\Category     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))                 ;
                  
                  Keeper\Archived     =           GetDatabaseString(Program\DatabaseHandle,  3)                  ;
                  
                  Keeper\Favourite    =           GetDatabaseString(Program\DatabaseHandle,  4)                  ;
                  
                  Keeper\Locked       =           GetDatabaseString(Program\DatabaseHandle,  5)                  ;
                  
                  Keeper\Deleted      =           GetDatabaseString(Program\DatabaseHandle,  6)                  ;
                  
                  Keeper\Updated      =   IsoDate(GetDatabaseString(Program\DatabaseHandle,  7), "NormalDate")   ;
                  
                  Keeper\Owner        =           GetDatabaseString(Program\DatabaseHandle,  8)                  ;
                  
                  Keeper\Attachments  =           GetDatabaseString(Program\DatabaseHandle,  9)                  ;
                  
                  Keeper\Record       =           GetDatabaseString(Program\DatabaseHandle, 10)                  ;
                  
                Wend
                
                FinishDatabaseQuery(Program\DatabaseHandle)
                
              Else
                
                SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty.", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetGadgetText(#Gadget_Data_Title,         Keeper\Title)
              
              SetGadgetText(#Gadget_Data_Details,       Keeper\Information)
              
              If Keeper\Category <> #Empty$
                
                SetGadgetText(#Gadget_Data_cCategory,   Keeper\Category)
                
              Else
                
                SetGadgetState(#Gadget_Data_cCategory,  #FirstItem)
                
              EndIf
              
              If Keeper\Owner <> #Empty$
                
                SetGadgetText(#Gadget_Data_Owner,       Keeper\Owner)
                
              Else
                
                SetGadgetState(#Gadget_Data_Owner,      #FirstItem)
                
              EndIf
              
              SetGadgetText(#Gadget_Data_Recordnumber,  Keeper\Record)
        
              ;------------------------------------------------------------------------------------
              ; Set the current operation details on the the main window status bar
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info",  Program\LastWindow + "   --   Record number: " + Str(NextRecord.i) + " ?", #PB_Compiler_Procedure)
              
              ;--------------------------------------------------------------------------------------------
              ; Disable the favourite icon in a new record as it isn't set here
              ;--------------------------------------------------------------------------------------------
              
              If Keeper\Favourite = "0"
                
                HideGadget(#Gadget_Data_Status, #True)
                
              ElseIf  Keeper\Favourite = "1"
                
                HideGadget(#Gadget_Data_Status, #False)
                
                SetGadgetColor(#Gadget_Data_Details, #PB_Gadget_BackColor, $F6FFFF)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              HideWindow(#Window_Data, #False)
              
              ;------------------------------------------------------------------------------------
              ; Set focus on the appointment name field
              ;------------------------------------------------------------------------------------
              
              SetActiveGadget(#Gadget_Data_Title)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Error",  "Could not open the [" + Program\LastWindow  + "] window.", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Warn",  "The [" + Program\LastWindow + "] window is still open, close that one first.", #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "There was no record number found for the selected line.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn",  "Cannot edit a deleted record, recover it first.", #PB_Compiler_Procedure)
        
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot edit this record, it is currently locked.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There is no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 151
; FirstLine = 131
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0