﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Mark an item in the list as a favourite item
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure MarkAsFavourite()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Keeper_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentCategory.s = GetGadgetText(#Gadget_Keeper_Category)

  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current deleted state
    ;----------------------------------------------------------------------------------------------
    
    passFavourite.s       = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #FavouriteColumn)
    
    passLocked.s          = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #LockedColumn)
    
    passDeleted.s         = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #DeletedColumn)
    
    passRecord.s          = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If passLocked.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If passDeleted <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If  passFavourite.s = "0"
          
          passFavourite.s = "1"
          
        ElseIf  passFavourite.s = "1"
          
          passFavourite.s = "0"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; Proceed if we got a record number
        ;------------------------------------------------------------------------------------------
        
        If passRecord.s <> #Empty$
          
          ;----------------------------------------------------------------------------------------
          ; Try to delete the selected record from the database
          ;----------------------------------------------------------------------------------------
          
          QueryString.s = "UPDATE Keeper "
          
          QueryString.s + "SET Favourite  = '" + passFavourite.s + "' "
          
          QueryString.s + "WHERE Record = '"   + passRecord.s    + "'"
          
          ;----------------------------------------------------------------------------------------
          ; Try to delete the selected record from the database
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If passLocked.s = "1"
              
              SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListLocked))
              
            ElseIf  passLocked.s <> "1"
              
              If passDeleted.s = "1"
                
                SetGadgetItemData(#Gadget_Keeper_Titles,  CurrentLine.i, Val(passDeleted.s))
                
                RedrawWindow_(GadgetID(#Gadget_Keeper_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
                
                SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListDeleted))
                
              ElseIf passDeleted.s <> "1"
                
                If passFavourite.s = "1"
                  
                  SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListFavourite))
                  
                ElseIf Favourite.s <> "1"
                  
                  SetGadgetItemImage(#Gadget_Keeper_Titles, CurrentLine.i, ImageID(#Image_ListNormal))
                  
                EndIf
                
              EndIf
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If CurrentCategory.s <> "Favourites" And passFavourite.s = "1"
              
              RemoveGadgetItem(#Gadget_Keeper_Titles, CurrentLine.i)
              
            ElseIf  CurrentCategory.s = "Favourites" And passFavourite.s = "0"
              
              RemoveGadgetItem(#Gadget_Keeper_Titles, CurrentLine.i)
                
            EndIf
          
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetGadgetItemText(#Gadget_Keeper_Titles,  CurrentLine.i, passFavourite.s, #FavouriteColumn)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Warn", "No record number found for line " + Str(CurrentLine.i), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "Cannot mark a deleted item as a favourite.", #PB_Compiler_Procedure)
        
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot mark a locked record as a favourite.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no current line selected.", #pb_compiler_procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 186
; FirstLine = 150
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0