﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Print all or selected records
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure PrintThisData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_Keeper_Titles) - 1
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\WindowMutex <> #True
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Window_print()
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Message.s = "Print all selected keeper items in the list"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_print, Message.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info", Message.s, #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_print, #ShortcutValue_NowPrint,      #KeyboardShortcut_NowPrint)
      
      AddKeyboardShortcut(#Window_print, #ShortcutValue_NowPreview,    #KeyboardShortcut_NowPreview)
      
      AddKeyboardShortcut(#Window_print, #ShortcutValue_ExitPrint,     #KeyboardShortcut_ExitPrint)
      
      AddKeyboardShortcut(#Window_print, #ShortcutValue_EscapePrint,   #KeyboardShortcut_EscapePrint)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddHoverGadget(GadgetID(#Gadget_Print_PrintNow))
      
      AddHoverGadget(GadgetID(#Gadget_Print_PrintPreview))
      
      AddHoverGadget(GadgetID(#Gadget_Print_PrintExit))

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      WebObject = GetWindowLongPtr_(GadgetID(#Gadget_Print_Sites), #GWL_USERDATA)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Program\WindowMutex = #True
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If NumberOfItems.i  <> #NoItems
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        PrintFileId.i = CreateFile(#PB_Any, Program\WebPrintFile)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If PrintFileId.i  <> #NoPrintFileHandle
          
          ;----------------------------------------------------------------------------------------
          ; Write the top of the template here
          ;----------------------------------------------------------------------------------------
          
          Restore _MGB_HtmlTop
          
          While TempString.s <> "_MGB_HtmlTop_END_"
            
            Read.s TempString.s
            
            If TempString.s <> "_MGB_HtmlTop_END_"
              
              WriteStringN(PrintFileId.i, TempString.s)
              
            EndIf
            
          Wend
          
          TempString.s = "<><>"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          For PrintLoop.i = 0 To NumberOfItems.i
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If GetGadgetItemState(#Gadget_Keeper_Titles, PrintLoop.i) & #PB_ListIcon_Selected
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              Record.s = GetGadgetItemText(#Gadget_Keeper_Titles, PrintLoop.i, #RecordColumn)
              
              If DatabaseQuery(Program\DatabaseHandle, "SELECT * FROM Keeper WHERE Record = '" + Record.s + "'")
                
                PseudoCounter + 1
                
                While NextDatabaseRow(Program\DatabaseHandle)
                  
                  Title.s       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))  : ; Debug Title.s       ; Title
                  
                  Information.s = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))  : ; Debug Information.s ; Information
                  
                Wend
                
                FinishDatabaseQuery(Program\DatabaseHandle)
              
              Else
                
                SetInfoBarArea("Headings", "Error", "The current SQL query failed to be executed.", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              Information.s = ReplaceString(Information.s, "-------------------------------------------------------", #Empty$, #PB_String_NoCase )
              
              Information.s = ReplaceString(Information.s, Chr(10), "<br>", #PB_String_NoCase )
              
;             Information.s = ReplaceString(Information.s, Chr(13), "<br>", #PB_String_NoCase )
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              Restore _MGB_HtmlMiddle
              
              While TempString.s <> "_MGB_HtmlMiddle_END_"
                
                Read.s TempString.s
                
                If TempString.s <> "_MGB_HtmlMiddle_END_"
                  
                  If FindString(TempString.s, "MGB_Title", #PB_String_NoCase) <> 0
                    
                    TempString.s = ReplaceString(TempString.s, "MGB_Title",       "Record title: >> " + Title.s)
                    
                  EndIf 
                  
                  If FindString(TempString.s, "MGB_Information", #PB_String_NoCase) <> 0
                    
                    TempString.s = ReplaceString(TempString.s, "MGB_Information", "Record information: >><br><br>" + Information.s  + "<br><br>")
                    
                    TempString.s + "___________________::: End Of Record ::: __________________<br><br>"
                    
                  EndIf
                  
                  WriteStringN(PrintFileId.i, TempString.s)
                  
                EndIf
                
              Wend
              
              TempString.s = "<><>"
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
            
          Next PrintLoop.i
          
          ;----------------------------------------------------------------------------------------
          ; Write the bottom of the template here
          ;----------------------------------------------------------------------------------------
          
          Restore _MGB_HtmlBottom
          
          While TempString.s <> "_MGB_HtmlBottom_END_"
            
            Read.s TempString.s
            
            If TempString.s <> "_MGB_HtmlBottom_END_"
              
              WriteStringN(PrintFileId.i, TempString.s)
              
            EndIf
            
          Wend
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CloseFile(PrintFileId.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Print_Sites, Program\WebPrintFile)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Print_Record, Str(PseudoCounter.i))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetActiveWindow(#Window_print)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetActiveGadget(#Gadget_Print_Sites)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          ; Debug "Could not create ouput print file"
          
          SetInfoBarArea("Headings", "Error", "Could not create ouput print file", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        ; Debug "No items in the list to process"
        
        SetInfoBarArea("Headings", "Info", "No items in the list to process", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ; Debug "Cannot open the Keeper print window"
      
      SetInfoBarArea("Headings", "Error", "Cannot open the Keeper print window", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; Debug "There is another program window open, cannot open another one"
    
    SetInfoBarArea("Headings", "Error", "There is another program window open, cannot open another one", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0