﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Save the new or edited Keeper data
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SaveThisData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Keeper\Title        = RepQuote(GetGadgetText(#Gadget_Data_Title))
  
  Keeper\Information  = RepQuote(GetGadgetText(#Gadget_Data_Details))
  
  Keeper\Category     = RepQuote(GetGadgetText(#Gadget_Data_cCategory))
  
; Keeper\Archived     = RepQuote(GetGadgetText(Gadget_Data_Archived))
  
; Keeper\Favourite    = RepQuote(GetGadgetText(#Gadget_Data_Favourite))

; Keeper\Locked       = RepQuote(GetGadgetText(#Gadget_Data_Locked))

; Keeper\Deleted      = RepQuote(GetGadgetText(#Gadget_Data_Deleted))

  Keeper\Updated      = FormatDate("%yyyy-%mm-%dd", Date())              ; ISO standard date format
  
  Keeper\Owner        = RepQuote(GetGadgetText(#Gadget_Data_Owner))
  
; Keeper\Attachments  = "0"
  
; Keeper\Record       = RepQuote(GetGadgetText(#Gadget_Data_Recordnumber))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Keeper\Title <> #Empty$ And Keeper\Information <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Select Program\LastWindow
     
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Case  "Add New Keeper Item"
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Keeper\Archived     = "0"
        
        Keeper\Favourite    = "0"
        
        Keeper\Locked       = "0"
        
        Keeper\Deleted      = "0"
        
        Keeper\Attachments  = "0"
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        KeeperInsertString.s                + 

        "INSERT INTO Keeper("               + 
        
        "Title, "                           + 

        "Information, "                     + 

        "Category, "                        + 

        "Archived, "                        + 

        "Favourite, "                       + 

        "Locked, "                          + 

        "Deleted, "                         + 

        "Updated, "                         + 
        
        "Owwner, "                          + 

        "Attachments) "                     + 
        
        "VALUES("                           + 
        
        "'"   +   Keeper\Title        + "'" + 
        
        ", '" +   Keeper\Information  + "'" + 
        
        ", '" +   Keeper\Category     + "'" + 
        
        ", '" +   Keeper\Archived     + "'" + 
        
        ", '" +   Keeper\Favourite    + "'" + 
        
        ", '" +   Keeper\Locked       + "'" + 
        
        ", '" +   Keeper\Deleted      + "'" + 
        
        ", '" +   Keeper\Updated      + "'" + 
        
        ", '" +   Keeper\Owner        + "'" + 
        
        ", '" +   Keeper\Attachments  + "'" + 
        
        ")"
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, KeeperInsertString.s)  <> #DatabaseUpdateFail
          
          Keeper\Record = DatabaseLastInsertRowId()
          
          If Keeper\Record <> #Empty$
            
            If Toggle\MessageSave = #True
              
              MessageRequester("New Item", "New item: " + KillQuote(Keeper\Title)  + " has been saved to the database", #PB_MessageRequester_Ok)
            
            EndIf
            
            NewNumberOfItems.i = CountGadgetItems(#Gadget_Keeper_Titles)
            
            DisplayTitleString(NewNumberOfItems.i,  "AddMode")
            
            LastLine(#Gadget_Keeper_Titles, NewNumberOfItems.i - 1)
            
          Else
            
            SetInfoBarArea("Headings",  "Error",  "No record number created " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Database table failed to be updated " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
          
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Case "Edit Old Keeper Item"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        KeeperUpdateString.s                                  + 

        "UPDATE Keeper SET "                                  + 
        
        "Title = '"         + Keeper\Title           + "', "  + 
        
        "Information = '"   + Keeper\Information     + "', "  + 
        
        "Category = '"      + Keeper\Category        + "', "  + 
        
       ;"Archived = '"      + Keeper\Archived        + "', "  + 
        
       ;"Favourite = '"     + Keeper\Favourite       + "', "  + 
       
       ;"Locked = '"        + Keeper\Locked          + "', "  + 

       ;"Deleted = '"       + Keeper\Deleted         + "'  "  + 
        
        "Updated = '"       + Keeper\Updated         + "', "  + 
        
        "Owner = '"         + Keeper\Owner           + "'  "  + 
        
       ;"Attachments = '"   + Keeper\Attachments     + "'  "  + 
        
        "WHERE Record = '"  + Program\CurrentRecord  + "'"
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, KeeperUpdateString.s)
          
          If Toggle\MessageSave = #True
            
            MessageRequester("Old Item", "Old item: " + KillQuote(Keeper\Title)  + " has been saved to the database", #PB_MessageRequester_Ok)
          
          EndIf
          
          DisplayTitleString(Program\CurrentLine, "EditMode")
          
          LogFile.i = OpenFile(#PB_Any, Program\CurrentDirectory + "EditRecordLog.txt")
          
          If LogFile.i 
            
            WriteStringN(LogFile.i, "Edit of record worked okay")
            
            WriteStringN(LogFile.i, "--------------------------")
            
            WriteStringN(LogFile.i, UpdateString.s)
            
            WriteStringN(LogFile.i, "--------------------------")
            
            CloseFile(LogFile.i)
            
          Else
            
            SetInfoBarArea("Headings", "Warn",  "Error writing to log file", #PB_Compiler_Procedure)
            
          EndIf
          
        Else
          
          If LogFile.i 
            
            WriteStringN(LogFile.i, "Edit of record didn't work")
            
            WriteStringN(LogFile.i, "--------------------------")
            
            WriteStringN(LogFile.i, UpdateString.s)
            
            WriteStringN(LogFIle.i, DatabaseError())
            
            WriteStringN(LogFile.i, "--------------------------")
            
            CloseFile(LogFile.i)
            
          Else
            
            SetInfoBarArea("Headings", "Warn",  "Editing of this record failed", #PB_Compiler_Procedure)
            
          EndIf

          SetInfoBarArea("Headings", "Error", "Database table failed to be updated " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\ReFocusLine = Program\CurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseMyWindow(#Window_Data)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    UpdateCategoryItemCount(Keeper\Category)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ;SortTitleStrings(Keeper\Title)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
  Else
    
    SetInfoBarArea("Headings",  "Error",  "The title and information fields must not be empty", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 294
; FirstLine = 249
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0