﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Import an XML file of keeper entries
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ImportDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportFile.s = OpenFileRequester("Import file from", Program\TemporaryDirectory, "XML file (*.xml)|*.xml", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ImportFile.s <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; Did we get a file handle?
    ;----------------------------------------------------------------------------------------------
    
    ImportFileId.i = LoadXML(#PB_Any, ImportFile.s)
    
    ;----------------------------------------------------------------------------------------------
    ; Did we get a file handle?
    ;----------------------------------------------------------------------------------------------
    
    If ImportFileId.i <> #NoImportFileHandle
      
      ;--------------------------------------------------------------------------------------------
      ; Start the SQL command transactions to speed up additions to the database
      ;--------------------------------------------------------------------------------------------
      
      DatabaseUpdate(Program\DatabaseHandle, "Begin Transaction")
      
      ;--------------------------------------------------------------------------------------------
      ; Get the main node of the XML document
      ;--------------------------------------------------------------------------------------------
      
      *MainNode = MainXMLNode(ImportFileId.i)
      
      ;--------------------------------------------------------------------------------------------
      ; Parse the XML file
      ;--------------------------------------------------------------------------------------------
      
      ProcessKeeperNode(*MainNode, CurrentSublevel.i)
      
      ;--------------------------------------------------------------------------------------------
      ; Commit All the SQL transactions to the database
      ;--------------------------------------------------------------------------------------------
      
      DatabaseUpdate(Program\DatabaseHandle, "Commit")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info",  "The keeper import file has been processed and imported", #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "The keeper import file has not been processed or imported", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "Nothing to do, user has cancelled the import process", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0