﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; A generic error handler for reporting crashes.
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ErrorHandler()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Message.s = "A program error has been detected:"                        + #CR$ 

  Message.s +                                                               #CR$

  Message.s + "Error Message: "     + #TAB$ +     ErrorMessage()          + #CR$

  Message.s + "Error Code: "        + #TAB$ + Str(ErrorCode())            + #CR$  

  Message.s + "Code Address:"       + #TAB$ + Str(ErrorAddress())         + #CR$

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ErrorCode() = #PB_OnError_InvalidMemory   

    Message.s + "Target Address:  " + #TAB$ + Str(ErrorTargetAddress()) + #CR$

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ErrorLine() = -1

    Message.s + "Sourcecode line: Enable OnError lines support to get code line information." + #CR$

  Else

    Message.s + "Source line: "     + #TAB$ + Str(ErrorLine()) + #CR$

    Message.s + "Source file: "     + #TAB$ +     ErrorFile()  + #CR$

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Message.s + #CR$

  Message.s + "Register content:" + #CR$

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CompilerSelect #PB_Compiler_Processor 

    CompilerCase #PB_Processor_x86

      Message.s + "EAX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_EAX)) + #CR$

      Message.s + "EBX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_EBX)) + #CR$

      Message.s + "ECX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_ECX)) + #CR$

      Message.s + "EDX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_EDX)) + #CR$

      Message.s + "EBP = " + #TAB$ + Str(ErrorRegister(#PB_OnError_EBP)) + #CR$

      Message.s + "ESI = " + #TAB$ + Str(ErrorRegister(#PB_OnError_ESI)) + #CR$

      Message.s + "EDI = " + #TAB$ + Str(ErrorRegister(#PB_OnError_EDI)) + #CR$

      Message.s + "ESP = " + #TAB$ + Str(ErrorRegister(#PB_OnError_ESP)) + #CR$

    CompilerCase #PB_Processor_x64

      Message.s + "RAX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RAX)) + #CR$

      Message.s + "RBX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RBX)) + #CR$

      Message.s + "RCX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RCX)) + #CR$

      Message.s + "RDX = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RDX)) + #CR$

      Message.s + "RBP = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RBP)) + #CR$

      Message.s + "RSI = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RSI)) + #CR$

      Message.s + "RDI = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RDI)) + #CR$

      Message.s + "RSP = " + #TAB$ + Str(ErrorRegister(#PB_OnError_RSP)) + #CR$

      Message.s + "Display of registers R8-R15 skipped."                 + #CR$

  CompilerEndSelect

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  MessageRequester("OnError example", Message.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  End

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0