﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; View the system error log file
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ViewErrorLog()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ErrorFileHandle.i = ReadFile(#PB_Any, Program\ErrorFile)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ErrorFileHandle.i <> #NoFileHandle
    
    ;----------------------------------------------------------------------------------------------
    ; Check if another window isn't open first
    ;----------------------------------------------------------------------------------------------
    
    If Program\WindowMutex <> #True
      
      ;--------------------------------------------------------------------------------------------
      ; Check to see if the Location window could be opened
      ;--------------------------------------------------------------------------------------------
      
      If Window_Errorlog()  <> #NoWindowId
        
        ;------------------------------------------------------------------------------------------
        ; If there are no other open windows, set the window open flag
        ;------------------------------------------------------------------------------------------
        
        Program\WindowMutex = #True
        
        ;------------------------------------------------------------------------------------------
        ; Add this window's fast escape shortcut
        ;------------------------------------------------------------------------------------------
        
        AddKeyboardShortcut(#Window_Errorlog, #ShortcutValue_EscapeErrorlog,  #KeyboardShortcut_EscapeErrorlog)
        
        AddKeyboardShortcut(#Window_Errorlog, #ShortcutValue_ExitErrorlog,    #KeyboardShortcut_ExitErrorlog)
        
        ;------------------------------------------------------------------------------------------
        ; Disable all input on the main window until this one is closed
        ;------------------------------------------------------------------------------------------
        
        DisableWindow(#Window_Keeper, #True)
        
        ;------------------------------------------------------------------------------------------
        ; Hide the main window until we are finished with the data window
        ;------------------------------------------------------------------------------------------
        
        HideWindow(#Window_Keeper, #True)
        
        ;------------------------------------------------------------------------------------------
        ; Add the window title for various procedures and visuals
        ;------------------------------------------------------------------------------------------
        
        Program\LastWindow = "View Error Log"
        
        ;------------------------------------------------------------------------------------------
        ; Add a generic message for info bars and title areas
        ;------------------------------------------------------------------------------------------
        
        Message.s = "View the error log"
        
        ;------------------------------------------------------------------------------------------
        ; Set the window title bar with the record number and message
        ;------------------------------------------------------------------------------------------
        
        SetWindowTitle(#Window_Errorlog, Message.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        For ReadHeading.i = 1 To 3
  
          EmptyString.s = ReadString(ErrorFileHandle.i)
          
          If FindString(EmptyString.s, "New Keeper Stuff", 1, #PB_String_NoCase)  <> #NoStringFound
            
            SetWindowTitle(#Window_Errorlog, Message.s  + ", [" + EmptyString.s + "]")
            
          EndIf
          
        Next ReadHeading.i
        
        While Eof(ErrorFileHandle.i) = #NotEndOfFile
          
          TemporaryString.s = ReadString(ErrorFileHandle.i)
          
          TemporaryString.s = ReplaceString(TemporaryString.s, "|",        #LF$, #PB_String_NoCase, 1)
          
          TemporaryString.s = RemoveString(TemporaryString.s, "Time::",          #PB_String_NoCase, 1)
          
          TemporaryString.s = RemoveString(TemporaryString.s, "Module::",        #PB_String_NoCase, 1)
          
          TemporaryString.s = RemoveString(TemporaryString.s, "Message::",       #PB_String_NoCase, 1)
          
          TemporaryString.s = Trim(TemporaryString.s, " ")
          
          AddGadgetItem(#Gadget_Errorlog_Errors, #AtTheEndOfTheList, TemporaryString.s, 0)
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; Make sure this window is active for input
        ;------------------------------------------------------------------------------------------
        
        SetActiveWindow(#Window_Errorlog)
        
        ;------------------------------------------------------------------------------------------
        ; Make sure the itemname field is ready for input
        ;------------------------------------------------------------------------------------------
        
        SetActiveGadget(#Gadget_Errorlog_Errors)
        
        ;------------------------------------------------------------------------------------------
        ; Add the message to the main window fake status area
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings",  "Info",  Message.s, #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; Go here if we could not open this data sheet window
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn",  "Could not open the "  + Program\LastWindow  + " window.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseFile(ErrorFileHandle.i)
    
      ;--------------------------------------------------------------------------------------------
      ; Go here if there is another program window open. Programmer error
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  Program\LastWindow + " is still open bozo, close that one first.", #PB_Compiler_Procedure)
      
    EndIf
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "Could not open the error log list. May be damaged or does not exist.", #PB_Compiler_Procedure)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; Nothing more to do folks
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 159
; FirstLine = 132
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode