﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Adaptable help file that loads RTF from datasection
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ShowHelp(Section.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Macro MakeLong(low, high)
    
    low | high << 16
    
  EndMacro 

  ;------------------------------------------------------------------------------------------------
  ; Try to open the help form window
  ;------------------------------------------------------------------------------------------------
  
  If Window_Help()
    
    ;----------------------------------------------------------------------------------------------
    ; Allow the editorgadget to send back event messages. Sparkie/Srod
    ;----------------------------------------------------------------------------------------------
    
    CurrentFlags.l = SendMessage_(GadgetID(#Gadget_Help_Help), #EM_GETEVENTMASK, 0, 0)
    
    SendMessage_(GadgetID(#Gadget_Help_Help), #EM_SETEVENTMASK, 0, #ENM_MOUSEEVENTS | #ENM_CHANGE | CurrentFlags)
    
    ;----------------------------------------------------------------------------------------------
    ; Find character defaults for the editor
    ;----------------------------------------------------------------------------------------------
    
    SendMessage_(GadgetID(#Gadget_Help_Help), #EM_GETCHARFORMAT, #SC_DEFAULT, defaultFormat)
    
    defaultFormat\cbSize = SizeOf(CHARFORMAT)
    
    defaultFormat\dwMask = #CFM_ITALIC  | #CFM_BOLD | #CFM_STRIKEOUT | #CFM_UNDERLINE
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    StickyWindow(#Window_Help, #True)
    
    ;----------------------------------------------------------------------------------------------
    ; Window was opened so set mutex to prevent other windows from opening
    ;----------------------------------------------------------------------------------------------

    ;Program\Mutex = #True
    
    ;----------------------------------------------------------------------------------------------
    ; Prevent user input on the main window
    ;----------------------------------------------------------------------------------------------
    
    ;DisableWindow(#Window_Keeper, #True)
    
    ;----------------------------------------------------------------------------------------------
    ; Add the fast form close keyboard shortcut
    ;----------------------------------------------------------------------------------------------
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_LoadHelp,          #KeyboardShortcut_LoadHelp)
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_SaveHelp,          #KeyboardShortcut_SaveHelp)
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_SearchHelp,        #KeyboardShortcut_SearchHelp)
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_PrintHelp,         #KeyboardShortcut_PrintHelp)
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_EditHelp,          #KeyboardShortcut_EditHelp)
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_ExitHelp,          #KeyboardShortcut_ExitHelp)
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_EscapeHelp,        #KeyboardShortcut_EscapeHelp)
    
    AddKeyboardShortcut(#Window_Help, #ShortcutValue_SearchOnEnter,     #KeyboardShortcut_SearchOnEnter)
    
    ;----------------------------------------------------------------------------------------------
    ; Add the fast form close keyboard shortcut
    ;----------------------------------------------------------------------------------------------
    
    AddHoverGadget(GadgetID(#Gadget_Help_LoadHelp))
    
    AddHoverGadget(GadgetID(#Gadget_Help_SaveHelp))
    
    AddHoverGadget(GadgetID(#Gadget_Help_SearchHelp))
    
    AddHoverGadget(GadgetID(#Gadget_Help_PrintHelp))
    
    AddHoverGadget(GadgetID(#Gadget_Help_EditHelp))
    
    AddHoverGadget(GadgetID(#Gadget_Help_ExitHelp))
    
    ;----------------------------------------------------------------------------------------------
    ; Setup your button tooltip messages, nicely spaced out
    ;----------------------------------------------------------------------------------------------
    
    If Program\BalloonFontId
      
      BalloonToolTip(#Window_Help, #Gadget_Help_LoadHelp,   Program\BalloonFontId, $BFBFBF, ShortTooltip\LoadHelp,    #CRLF$ + GetShortCutText(#ShortcutValue_LoadHelp)   + #CRLF$ + #CRLF$ + LongTooltip\LoadHelp,   GetIconHandle(#Image_Help_LoadHelp))
      
      BalloonToolTip(#Window_Help, #Gadget_Help_SaveHelp,   Program\BalloonFontId, $BFBFBF, ShortTooltip\SaveHelp,    #CRLF$ + GetShortCutText(#ShortcutValue_SaveHelp)   + #CRLF$ + #CRLF$ + LongTooltip\SaveHelp,   GetIconHandle(#Image_Help_SaveHelp))
      
      BalloonToolTip(#Window_Help, #Gadget_Help_SearchHelp, Program\BalloonFontId, $BFBFBF, ShortTooltip\SearchHelp,  #CRLF$ + GetShortCutText(#ShortcutValue_SearchHelp) + #CRLF$ + #CRLF$ + LongTooltip\SearchHelp, GetIconHandle(#Image_Help_SearchHelp))
      
      BalloonToolTip(#Window_Help, #Gadget_Help_PrintHelp,  Program\BalloonFontId, $BFBFBF, ShortTooltip\PrintHelp,   #CRLF$ + GetShortCutText(#ShortcutValue_PrintHelp)  + #CRLF$ + #CRLF$ + LongTooltip\PrintHelp,  GetIconHandle(#Image_Help_PrintHelp))
      
      BalloonToolTip(#Window_Help, #Gadget_Help_EditHelp,   Program\BalloonFontId, $BFBFBF, ShortTooltip\EditHelp,    #CRLF$ + GetShortCutText(#ShortcutValue_EditHelp)   + #CRLF$ + #CRLF$ + LongTooltip\EditHelp,   GetIconHandle(#Image_Help_EditHelp))
      
      BalloonToolTip(#Window_Help, #Gadget_Help_ExitHelp,   Program\BalloonFontId, $BFBFBF, ShortTooltip\ExitHelp,    #CRLF$ + GetShortCutText(#ShortcutValue_ExitHelp)   + #CRLF$ + #CRLF$ + LongTooltip\ExitHelp,   GetIconHandle(#Image_Help_ExitHelp))
      
    Else
      
      MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
      
      End
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Remove border from editorgadget (comment) field. Still leaves a 1 pixel border but that looks good here
    ;----------------------------------------------------------------------------------------------
    
    RemoveBorders(#Gadget_Help_Help)
    
    ;----------------------------------------------------------------------------------------------
    ; Make sure we don't load or save the help file from previous sessions
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentHelpFileName = #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; Alias out the needed help page to the right filename
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentHelpFileName = Program\HelpDirectory  + Section.s  + ".Rtf"
    
    ;----------------------------------------------------------------------------------------------
    ; Tell the user that we are in read only mode for the help text
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_Help_EditMode, "Read Only: "  + Section.s  + ".Rtf")
    
    ;----------------------------------------------------------------------------------------------
    ; RASHAD.
    ;----------------------------------------------------------------------------------------------
    
    SendMessage_(GadgetID(#Gadget_Help_Help), #EM_LIMITTEXT, -1, 0)
    
    ;----------------------------------------------------------------------------------------------
    ; Sparkie. Set a left margin of 10 pixels on the left and the right
    ;----------------------------------------------------------------------------------------------
    
    SendMessage_(GadgetID(#Gadget_Help_Help), #EM_SETMARGINS, #EC_LEFTMARGIN,  MakeLong(10, 0))
    
    SendMessage_(GadgetID(#Gadget_Help_Help), #EM_SETMARGINS, #EC_RIGHTMARGIN, MakeLong(10, 0))
    
    ;----------------------------------------------------------------------------------------------
    ; Load the RTF data into the note area from a file on the hard disk
    ;----------------------------------------------------------------------------------------------
    
    If FileSize(Program\CurrentHelpFileName) <> #FileDoesNotExist
      
      Editor_Load(#Gadget_Help_Help, Program\CurrentHelpFileName)
      
    Else
      
      SetInfoBarArea("Headings", "Error", Program\CurrentHelpFileName  + " could not be loaded. Missing, damaged or doesn't exist yet.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Setup the common add window message
    ;----------------------------------------------------------------------------------------------
    
    Message.s = "Showing Mystuff help for: " + Section.s
    
    ;----------------------------------------------------------------------------------------------
    ; Set the last window message for the closure routine later
    ;----------------------------------------------------------------------------------------------
    
    Program\LastWindow = Message.s
    
    ;----------------------------------------------------------------------------------------------
    ; Set the new message to the window title
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_Help, Message.s)
    
    ;----------------------------------------------------------------------------------------------
    ; Show the new message on the status bar area as well
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info", Message.s, #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; Make sure the data form window is topmost
    ;----------------------------------------------------------------------------------------------
    
    SetActiveWindow(#Window_Help)
    
    ;----------------------------------------------------------------------------------------------
    ; Make sure the version field is selected
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_Help_FindHelp)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "The program window could not be opened.", #PB_Compiler_Procedure)
    
  EndIf
    
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 231
; FirstLine = 189
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0