﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Edit the old owner in the database
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure EditOwner()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Owner\CurrentLine.i      = GetGadgetState(#Gadget_OwnerList_Owners)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Owner\CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Owner\CurrentRecord.s = GetGadgetItemText(#Gadget_OwnerList_Owners, Owner\CurrentLine.i, #OwnerRecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Owner\CurrentRecord.s <> #Empty$
      
      ;--------------------------------------------------------------------------------------------
      ; Check if another window isn't open first
      ;--------------------------------------------------------------------------------------------
      
      If Program\LastChildWindow <> "Add New Owner"
        
        ;------------------------------------------------------------------------------------------
        ; Check to see if the Location window could be opened
        ;------------------------------------------------------------------------------------------
        
        If Window_Owner()  <> #NoWindowId
          
          ;----------------------------------------------------------------------------------------
          ; If there are no other open windows, set the window open flag
          ;----------------------------------------------------------------------------------------
          
          Program\LastChildWindow = "Edit Old Owner"
          
          ;----------------------------------------------------------------------------------------
          ; Add this window's fast escape shortcut
          ;----------------------------------------------------------------------------------------
          
          AddKeyboardShortcut(#Window_Owner, #ShortcutValue_SaveOwner,    #KeyboardShortcut_SaveOwner)
          
          AddKeyboardShortcut(#Window_Owner, #ShortcutValue_HelpOwner,    #KeyboardShortcut_Helpowner)
          
          AddKeyboardShortcut(#Window_Owner, #ShortcutValue_ExitOwner,    #KeyboardShortcut_ExitOwner)
          
          AddKeyboardShortcut(#Window_Owner, #ShortcutValue_EscapeOwner,  #KeyboardShortcut_Escapeowner)
          
          ;----------------------------------------------------------------------------------------
          ; Add the hoverable controls
          ;----------------------------------------------------------------------------------------
          
          AddHoverGadget(GadgetID(#Gadget_Owner_SaveOwner))
          
          AddHoverGadget(GadgetID(#Gadget_Owner_HelpOwner))
          
          AddHoverGadget(GadgetID(#Gadget_Owner_ExitOwner))
          
          ;----------------------------------------------------------------------------------------
          ; These are your balloon tooltips used on the main form. All headings, balloon text and 
          ; icons are re-useable variables taken from the constants file.
          ;----------------------------------------------------------------------------------------
          
          If Program\BalloonFontId
            
            BalloonToolTip(#Window_Owner, #Gadget_Owner_SaveOwner, Program\BalloonFontId, $FFFFFF, ShortTooltip\SaveOwner,  #CRLF$ + GetShortCutText(#ShortcutValue_SaveOwner) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\SaveOwner, 30), GetIconHandle(#Image_Owner_SaveOwner))
            
            BalloonToolTip(#Window_Owner, #Gadget_Owner_HelpOwner, Program\BalloonFontId, $FFFFFF, ShortTooltip\HelpOwner,  #CRLF$ + GetShortCutText(#ShortcutValue_HelpOwner) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\HelpOwner, 30), GetIconHandle(#Image_Owner_HelpOwner))
            
            BalloonToolTip(#Window_Owner, #Gadget_Owner_ExitOwner, Program\BalloonFontId, $FFFFFF, ShortTooltip\ExitOwner,  #CRLF$ + GetShortCutText(#ShortcutValue_ExitOwner) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ExitOwner, 30), GetIconHandle(#Image_Owner_ExitOwner))
            
          Else
            
            MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
            
          EndIf            
          
          ;----------------------------------------------------------------------------------------
          ; Disable all input on the main window until this one is closed
          ;----------------------------------------------------------------------------------------
          
          DisableWindow(#Window_OwnerList, #True)
          
          ;----------------------------------------------------------------------------------------
          ; Hide the main window until we are finished with the data window
          ;----------------------------------------------------------------------------------------
          
          HideWindow(#Window_OwnerList, #True)
          
          ;----------------------------------------------------------------------------------------
          ; Load the user chosen icons to be selected for locations
          ;----------------------------------------------------------------------------------------
          
          DirectoryId.i = ExamineDirectory(#PB_Any, Program\OwnerIcons, "*.ico")
          
          If DirectoryId.i
            
            Repeat
              
              TypeOfFile.i  = NextDirectoryEntry(DirectoryId.i) 
              
              IconName.s    = DirectoryEntryName(DirectoryId.i)
              
              If TypeOfFile.i = #True And IconName.s <> "." And IconName.s <> ".."
                
                If FileSize(Program\OwnerIcons  + IconName.s) <> #FileDoesNotExist And FileSize(Program\OwnerIcons  + IconName.s) <> #FileIsDirectory
                  
                  IconHandle.i = LoadImage(#PB_Any, Program\OwnerIcons  + IconName.s)
                  
                  If IconHandle.i <>  #NoPictureLoaded
                    
                    AddGadgetItem(#Gadget_Owner_OwnerIcon, #AtTheEndOfTheList, IconName.s, ImageID(IconHandle.i))
                    
                  Else
                    
                    AddGadgetItem(#Gadget_Owner_OwnerIcon, #AtTheEndOfTheList, IconName.s, ImageID(#Image_ListNoowner))
                    
                    SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                    
                  EndIf
                  
                Else
                  
                  AddGadgetItem(#Gadget_Owner_OwnerIcon, #AtTheEndOfTheList, IconName.s, ImageID(#Image_ListNoowner))
                  
                  SetInfoBarArea("Headings", "Error", "Icon file does not exist or is damaged.", #PB_Compiler_Procedure)
                  
                EndIf
                
              EndIf 
              
            Until TypeOfFile.i = #False
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          DatabaseQuery.s = "SELECT Owner, Iconname FROM Owners "
          
          DatabaseQuery.s + "WHERE Record = '" + Owner\CurrentRecord.s  + "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
            
            While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
              
              OwnerName.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
              
              IconName.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1))
              
            Wend
            
            FinishDatabaseQuery(Program\DatabaseHandle)
            
          Else
            
            SetInfoBarArea("Headings",  "Warn", "Database query failed or returned no data: " +  DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Owner_OwnerName,  OwnerName.s)
          
          SetGadgetText(#Gadget_Owner_OwnerIcon,  IconName.s)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          NextRecordString.s  = " - Record: " + Owner\Currentrecord.s
          
          ;----------------------------------------------------------------------------------------
          ; Add a generic message for info bars and title areas
          ;----------------------------------------------------------------------------------------
          
          Message.s = Program\LastChildWindow
          
          ;----------------------------------------------------------------------------------------
          ; Set the window title bar with the record number and message
          ;----------------------------------------------------------------------------------------
          
          SetWindowTitle(#Window_Owner, Message.s + NextRecordString.s)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure this window is active for input
          ;----------------------------------------------------------------------------------------
          
          SetActiveWindow(#Window_Owner)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the itemname field is ready for input
          ;----------------------------------------------------------------------------------------
          
          SetActiveGadget(#Gadget_Owner_OwnerName)
          
          ;----------------------------------------------------------------------------------------
          ; Add the message to the main window fake status area
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings",  "Info",  Message.s + NextRecordString.s, #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; Go here if we could not open this data sheet window
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Warn",  "Could not open the "  + Program\LastChildWindow  + " window", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; Go here if there is another program window open. Programmer error
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  Program\LastChildWindow + " is still open bozo, close that one first", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Nothing more to do folks
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error", "There is no current record number on that line selected to be edited.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "There is no current line selected by the user.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode