﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Save the new or changed Owner information
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SaveOwner()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Ownername.s  = RepQuote(GetGadgetText(#Gadget_Owner_OwnerName))
  
  Iconname.s   = RepQuote(GetGadgetText(#Gadget_Owner_OwnerIcon))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select Program\LastChildWindow

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
      
    Case "Add New Owner"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Ownername.s  <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Len(Ownername.s) > = 6
          
          ;----------------------------------------------------------------------------------------
          ; Uppercase the first letter of the word
          ;----------------------------------------------------------------------------------------
          
          Ownername.s = UCase(Left(Ownername.s, 1)) + Mid(Ownername.s, 2, Len(Ownername.s) - 1)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          NewOwnerInsert.s            + 

          "INSERT INTO Owners("       + 
          
          "Owner, "                   + 
          
          "Iconname, "                + 
          
          "Itemcount) "               + 
          
          "VALUES("                   + 
          
          "'"                         + 

          Ownername.s                 + 

          "', "                       + 
          
          "'"                         + 

          Iconname.s                  + 

          "', "                       + 
          
          "'0')"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, NewOwnerInsert.s) <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            Newrecordnumber.s = DatabaseLastInsertRowId()
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If Newrecordnumber.s <> #Empty$
              
              If Toggle\MessageSave = #True
                
                MessageRequester("New Owner", "New owner: " + KillQuote(Ownername.s)  + " has been saved to the database", #PB_MessageRequester_Ok)
              
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If FileSize(Program\OwnerIcons  + Iconname.s) <> #NoPictureFound  And FileSize(Program\OwnerIcons  + Iconname.s) <> #FileIsDirectory
                
                UserIconHandle.i = LoadImage(#PB_Any, Program\OwnerIcons  + Iconname.s)
                
                If UserIconHandle.i <>  #NoPictureLoaded
                  
                  AddGadgetItem(#Gadget_OwnerList_Owners, #AtTheEndOfTheList, KillQuote(Ownername.s) + #LF$  + KillQuote(Iconname.s)  + #LF$  + Itemcount.s + #LF$  + Newrecordnumber.s, ImageID(UserIconHandle.i))
                  
                Else
                  
                  AddGadgetItem(#Gadget_OwnerList_Owners, #AtTheEndOfTheList, KillQuote(Ownername.s) + #LF$  + #Empty$  + #LF$  + KillQuote(Itemcount.s) + #LF$  + Newrecordnumber.s, ImageID(#Image_ListNoowner))
                  
                  SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                  
                EndIf
                
              Else
                
                AddGadgetItem(#Gadget_OwnerList_Owners, #AtTheEndOfTheList, KillQuote(Ownername.s) + #LF$  + #Empty$  + #LF$  + KillQuote(Itemcount.s) + #LF$  + Newrecordnumber.s, ImageID(#Image_ListNoowner))
                
                SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info", "Saved new Owner:  " + KillQuote(Ownername.s) + " into the database", #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Error", "Could not get a new record number for the new Owner.", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Error", "Could not save the new Owner into the database: " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Warn", "The new Owner is too short. 6 characters is not useful.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn", "No new Owner saved, user aborted the process.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Edit Old Owner"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Ownername.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        OldOwnerUpdate.s      + 

        "UPDATE Owners "      + 
        
        "SET Owner = '"       + 

        Ownername.s           + 

        "', "                 + 
        
        "Iconname = '"        + 

        Iconname.s            + 

        "' "                  + 
        
        "WHERE Record = '"    + 

        Owner\Currentrecord.s +

        "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, OldOwnerUpdate.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If Toggle\MessageSave = #True
            
            MessageRequester("Old Owner", "Old owner: " + KillQuote(Ownername.s)  + " has been saved to the database", #PB_MessageRequester_Ok)
          
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings",  "Info", "The edited Owner was saved to Owners.", #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          KeeperUpdate.s    +  

          "UPDATE Keeper "  + 

          "SET Owner = '"   + 

          Ownername.s       + 

          "' "              + 

          "WHERE Owner = '" +

          Owner\Owner.s     + 

          "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, KeeperUpdate.s) <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetGadgetItemText(#Gadget_OwnerList_Owners, Owner\CurrentLine.i, KillQuote(Ownername.s), #OwnerTitleColumn)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If FileSize(Program\OwnerIcons  + Iconname.s) <> #NoPictureFound  And FileSize(Program\OwnerIcons  + Iconname.s) <> #FileIsDirectory
              
              UserIconHandle.i = LoadImage(#PB_Any, Program\OwnerIcons  + Iconname.s)
              
              If UserIconHandle.i <>  #NoPictureLoaded
                
                SetGadgetItemImage(#Gadget_OwnerList_Owners, Owner\CurrentLine.i, ImageID(UserIconHandle.i))
                
              Else
                
                SetGadgetItemImage(#Gadget_OwnerList_Owners, Owner\CurrentLine.i, ImageID(#Image_ListNoowner))
                
                SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                
              EndIf
              
            Else
              
              SetGadgetItemImage(#Gadget_OwnerList_Owners, Owner\CurrentLine.i, ImageID(#Image_ListNoowner))
              
              SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetInfoBarArea("Headings",  "Info", "The changed Owner was updated in Mystuff.", #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Error", "The changed Owner could not be updated in Mystuff: " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error", "The edited Owner could not be saved to Categories: " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn", "The Owner string is empty so there is nothing to save.",  #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  UpdateOwnerItemCount(Ownername.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CloseMyWindow(#Window_Owner)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 353
; FirstLine = 310
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode