;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check that the old password and confirmation passwords match
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure CheckPassWords()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FocusId.i = GetActiveGadget()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select FocusId.i

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case #Gadget_EditPassword_ConfirmPassWord
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ConfirmPassWord.s = GetGadgetText(#Gadget_EditPassword_ConfirmPassWord)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If ConfirmPassWord.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ConfirmPassWord.s = Fingerprint(@ConfirmPassWord,  Len(ConfirmPassWord.s), #PB_Cipher_MD5)

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Program\OldPassWord <> ConfirmPassWord.s
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          MessageString.s = "Passwords do not match." + #CRLF$ + #CRLF$ + "Try again or press ESCape to exit."
          
          MessageRequester("Security Error", MessageString.s, #MB_ICONWARNING)
          
          SetGadgetText(#Gadget_EditPassword_ConfirmPassWord, #Empty$)
          
          SetActiveGadget(#Gadget_EditPassword_ConfirmPassWord)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        ElseIf Program\OldPassWord = ConfirmPassWord.s
          
          SetActiveGadget(#Gadget_EditPassword_NewPassWord)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        MessageString.s = "Confirmation password empty."  + #CRLF$ + #CRLF$ + "Try again or press ESCape to exit."

        MessageRequester("Security Error", MessageString.s, #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_EditPassword_ConfirmPassWord, #Empty$)
        
        SetActiveGadget(#Gadget_EditPassword_ConfirmPassWord)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Gadget_EditPassword_NewPassWord
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      NewPassWord.s = GetGadgetText(#Gadget_EditPassword_NewPassWord)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If NewPassWord.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Len(NewPassWord.s) > 7 And Len(NewPassWord.s) < 26
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Program\MD5FingerPrint = Fingerprint(@NewPassWord,  Len(NewPassWord.s), #PB_Cipher_MD5)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s                     + 

          "UPDATE Preferences "             + 
          
          "SET MD5FingerPrint = '"          + 

          RepQuote(Program\MD5FingerPrint)  + 

          "' "                              + 
          
          "WHERE Record = '1'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s) = 0
            
            MessageString.s = "This password is could not be saved."  + #CRLF$ + #CRLF$ + DatabaseError()
            
            MessageRequester("Database Error", MessageString.s,  #MB_ICONWARNING)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Program\OldPassword = #Empty$
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CloseMyWindow(#Window_EditPassword)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          MessageString.s = "This password is too short."  + #CRLF$ + #CRLF$  + "It must be between 8 and 25 characters in length."
          
          MessageRequester("Security Error", MessageString.s,  #MB_ICONWARNING)
          
          SetGadgetText(#Gadget_EditPassword_NewPassWord, #Empty$)
          
          SetActiveGadget(#Gadget_EditPassword_NewPassWord)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        MessageRequester("Security Error",  "The password field is empty, nothing was saved.",  #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_EditPassword_NewPassWord, #Empty$)
        
        SetActiveGadget(#Gadget_EditPassword_NewPassWord)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 200
; FirstLine = 157
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0